# !perl -w

# Dette skriptet ble brukt til  lage referanseleksikon for dekomponereren

open IN, "C:\\nor020124NST.pron\\nor020124NST.pron";
open OUT, ">decomp_lexicon.out";

$count = 0;

while (<IN>) {
	chomp;
	$count++;
	print "Processed entry $count\r" if $count =~ /0000$/;
	$linje = $_;
	@felt = split /;/, $linje;

	next if ($felt[3] =~ /[\-\_]/);		# gi blaffen i flerordsuttrykk
	next if ($felt[7]);		# fjerne sppel
	next if ($felt[9]);		# fjerne abbr/acr	

	if ($felt[31] !~ /^INFLECTED$/) {
		print OUT "$felt[0]\t$felt[3]\n";
	}
}
