# !perl -w

#open IN, "C:\\nor020124NST.pron\\decomp_lexicon_no_names.lex";
open IN, "C:\\nor020124NST.pron\\decomp_lexicon_BASE.lex";


#open IN, "F:\\TIT\\Ressourcer\\LDB\\NO\\LEXs\\nor020124NST.pron\\nor020124NST.lex";

open OUT_1, ">dec_aft_1_con.nd";
open OUT_2, ">dec_aft_2_con.nd";
open OUT_3, ">dec_aft_3_con.nd";
open OUT_4, ">dec_aft_4_con.nd";
open OUT_5, ">dec_aft_5_con.nd";
open OUT_6, ">dec_aft_6_con.nd";
open OUT_7, ">dec_aft_7_con.nd";

$count = 0;
$vow = 'a|e|i|o|u|y||||||||||||';
$con = 'b|c|d|f|g|h|j|k|l|m|n|p|q|r|s|t|v|w|x|z|||';
$db_con = 'bb|dd|ff|gg|kk|ll|mm|nn|pp|rr|ss|tt';

while (<IN>) {
	chomp;
	$count++;
	print "Processed entry $count\r" if $count =~ /0000$/;
	$linje = $_;
	@felt = split /\t/, $linje;
	$len = length $felt[0];
	
	$ort = $felt[0];
	$dec = $felt[1];

	next if ($ort =~ /[A-Z]/); 	# ignore names for now
#	next if ($dec !~ /\+/); 		# only complex for now
	
#	$dec =~ s/\+([a-z])+$//;		# get rid of last (inflected etc) element
	@ledd = split /\+/, $dec;
	
	foreach $ledd (@ledd) {
		if ($ledd =~ /($vow)($con)$/) {
			$dec_aft_1{$ledd}++;
		}
		elsif ($ledd =~ /($vow)($con)($con)$/) {
			$dec_aft_2{$ledd}++;
		}
		elsif ($ledd =~ /($vow)($con)($con)($con)$/) {
			$dec_aft_3{$ledd}++;
		}
		elsif ($ledd =~ /($vow)($con)($con)($con)($con)$/) {
			$dec_aft_4{$ledd}++;
		}
		elsif ($ledd =~ /($vow)($con)($con)($con)($con)($con)$/) {
			$dec_aft_5{$ledd}++;
		}
		elsif ($ledd =~ /($vow)($con)($con)($con)($con)($con)($con)$/) {
			$dec_aft_6{$ledd}++;
		}
		elsif ($ledd =~ /($vow)($con)($con)($con)($con)($con)($con)($con)$/) {
			$dec_aft_7{$ledd}++;
		}
	}
}

foreach $key (sort keys (%dec_aft_1)) {
	print OUT_1 "$key\n";
}
foreach $key (sort keys (%dec_aft_2)) {
	print OUT_2 "$key\n";
}
foreach $key (sort keys (%dec_aft_3)) {
	print OUT_3 "$key\n";
}
foreach $key (sort keys (%dec_aft_4)) {
	print OUT_4 "$key\n";
}
foreach $key (sort keys (%dec_aft_5)) {
	print OUT_5 "$key\n";
}
foreach $key (sort keys (%dec_aft_6)) {
	print OUT_6 "$key\n";
}
foreach $key (sort keys (%dec_aft_7)) {
	print OUT_7 "$key\n";
}
