# !perl -w

#open IN, "nor020124NST.decomp";
open IN, "C:\\nor020124NST.pron\\nor020124NST.lex";

open OUT, ">extract.out";

$stress = '\"\"|%|\"|\$|_|';
$count = 0;

$con = 'b|c|d|f|g|h|j|k|l|m|n|p|q|r|s|t|v|w|x|z';
$vow = 'a|e|i|o|u|y|||||';

$ptn = "kskr";

while (<IN>) {
	chomp;
	$count++;
	print "Processed entry $count\r" if $count =~ /0000$/;
	$linje = $_;
	@felt = split /\t/, $linje;
	$len = length $felt[0];
	
#	next if ($felt[1] =~ /\+/);	# NO DECOMP
#	if ($felt[0] =~ /^($ptn)/) {	# STARTS WITH

#	if ($felt[0] =~ /($ptn)/) {	# MATHCES
#	if ($felt[0] =~ /($vow)($ptn)($vow)/) {	# MATCHES
	if (($felt[1] =~ /!/) & ($felt[1] =~ /(b\+b|c\+c|d\+d|f\+f|g\+g|h\+h|j\+j|k\+k|l\+l|m\+m|n\+n|p\+p|q\+q|r\+r|s\+s|t\+t|v\+v|w\+w|x\+x|z\+z)/)) {
		print OUT "$linje\n";
	}
}


