#!perl -w
#uppdaterad 00.09.14 till version 8 som r den 'slutliga' versionen infr spotchecking av nomen
#uppdaterad 00.08.30/LW. Tar inte argument via en batfil utan allt mste specificeras direkt i denna filen
#uppdaterad 240500/ck gller fr substantiv,adjektiv,verb
#Call:  VIPS_shell.pl lang lexfile

$printarild = 1; # SET THIS TO 1 IF YOU WANT A FILE WITH INFLECTED FORMS, STEMS, LEMMAS, ENDINGS ETC.  OUTPUTS TO 'to_arild.OUT'.
$printstems = 0; # DO NOT SET THIS TO 1, doesent work any more/LW
$printlog = 0;   # PRESENTLY THE LOGFILE IS NOT WORKING PROPERLY
$printonlyOKposts = 1; # IF set to 1, accepts a lexikon with both ok and not ok posts according to last statusinfo in field 5, but disregards notokposts and posts marked as 'available'
$usedecomp = 0;  # if set to 1 uses decompstring instead of orthography

require 'VIPSswe_v8.pl';
require 'VIPS_v8.pl';
$rulefile = "VIPSswe_v8.rule";
#$lexfile = "all_telia6-v7_ok_ARILD_regexp.out";
#$lexfile = "TEST.LEX";   ####################################  CHANGE LEXFILE TO INFLECT HERE!!!  #######################
#$lexfile = "leklex_adj_spotcheck.lex";   ####################################  CHANGE LEXFILE TO INFLECT HERE!!!  #######################
#$lexfile = "lw3rader.lex";   ####################################  CHANGE LEXFILE TO INFLECT HERE!!!  #######################
#$lexfile = "L:\\RESURSER_SE\\LEX\\LWCKCE\\Telia6mapp\\telia6-v8.lex_UPDATED_v5";   ####################################  CHANGE LEXFILE TO INFLECT HERE!!!  #######################
$lexfile = "L:\\SE_TRANSCRIPTION\\UPDATES\\MULTIWORDS\\RETURN\\telia6-v9";   ####################################  CHANGE LEXFILE TO INFLECT HERE!!!  #######################

$outfile = $rulefile."__".$lexfile."\.OUT";  ### output files name computed with rulefile and lexfile names appended with '.OUT'###



$postflag = 0;
@retposts = ();
open LOG,">VIPS_shell8.LOG" if $printlog;
open STEMS, ">VIPS_shell8.STEMS" if $printstems;
#open ARILD, ">to_arild8_14sept.OUT" if $printarild;
open ARILD, ">04_oct_inflected.OUT" if $printarild;


use locale;
use POSIX 'locale_h';
setlocale(LC_CTYPE,$locale{Swedish});


print LOG "Calling sub MkRuleHash($rulefile) returning a hash with paradigm name as key and subrule lines as values\n\n" if $printlog;
%raw_rules = &MkRuleHash($rulefile);
%rules = &PreprocessRule(%raw_rules);

print LOG "Opening a output file \'VIPS.OUT\'\n\n" if $printlog;
#open OUT,">$outfile";
open OUT,">04_oct.OUT";

print LOG "Opening a lexiconfile \'$ARGV[1]\' to process\n\n" if $printlog;
open LEX,"$lexfile";
while (<LEX>) {
	chomp;
	undef @globlist;
	@globlist = split /\t/;
	if (($globlist[5] !~ /status=OK[^<]+$/) and ($printonlyOKposts == 1)) {next}
#	($ort,$trk,$code,$decomp,$id) = (split /\t/)[1,3,10,2,20];
	($ort,$trk,$code,$decomp,$id) = @globlist[1,3,10,2,20];
#	$arild = "id=$id\t";
	($result,@retposts) = &vips($ort,$trk,$code,$decomp) unless $usedecomp;
	($result,@retposts) = &vips($decomp,$trk,$code,$decomp) if $usedecomp;	
#	($result,@retposts) = &vips(@lexlist);
#	print ARILD "$arild" if $printarild;
	print OUT "$result\n\n===========================================================\n\nNEXT LEXENTRY:\n\n";
	

}



close OUT;
close LOG if $printlog;
close STEMS  if $printstems;
close LEX;
close ARILD;
