# !perl -w

#Programmet analyserer alle dekomponerte ikke-garbage ord, 
#og klassifiserer forledd ut fra hvordan de danner sammensetninger. 

#open IN, "test.txt";
open IN, "dekomponerte_fellesnavn.txt";

#open LOGG, ">logg.OUT";
open OUT1, ">forledd_uten_fugemorfem.OUT";
open OUT2, ">forledd_med_fugemorfem.OUT";

@ufuge = "";
@mfuge = "";

$fuge = "(a|ar|e|en|er|es|n|r|s|-)";
$punc = "_|-";

while (<IN>) {
	chomp;
	$linje = $_;
	@felt = split ";", $linje;
	$corr = $felt[1];		#ortografi
	$decomp = $felt[2];		#dekomponering
	$pos = $felt[3];
	$decpos = $felt[4];
	$trans = $felt[11];
	$id = $felt[40];

	@ortledd = split /\+/, $decomp;		#hvert dekomponeringsledd

#print LOGG "New entry:\t$corr\t$decomp\n";

	for ($i = 0; $i < 10; $i++) {
		$curr = $ortledd[$i];
#print LOGG "\$curr:\t$curr\n";
		$n = $i+1;
		$m = $i+2;

		$next = $ortledd[$n];
#print LOGG "\$next:\t$next\n";

		$mext = $ortledd[$m];
#print LOGG "\$mext:\t$mext\n";


		if (($curr !~ /^$punc/) && ($next !~ /^$fuge$/) && ($next) && ($curr !~ /^$fuge$/)) {
			$item = "$curr"."\t$decomp"."\t$corr"."\t$trans";
			push @ufuge, $item;
		}
		
		elsif (($curr !~ /^$punc/) && ($next =~ /^$fuge$/) && ($next)) {
			$forledd = $curr.$next;
			$item = "$forledd"."\t$decomp"."\t$corr"."\t$trans";
			push @mfuge, $item;
		}
	}

#print LOGG "--------------\n";

}

foreach $entry (sort @ufuge) {
	print OUT1 "$entry\n";
}

foreach $entry (sort @mfuge) {
	print OUT2 "$entry\n";
}
