# !perl -w

#Programmet analyserer alle dekomponerte ikke-garbage ord, 
#og klassifiserer forledd ut fra hvordan de danner sammensetninger.
#Tilordner koder etter fuge, og skriver til n liste. 

open LEX, "simplex.txt";
#open LOGG, ">logg.OUT";
open OUT, ">fl_lh_no_addon.LEX";

%longlist = "";

while (<LEX>) {
	$code = "c0";
	$curr = "";
	$lccurr = "";
	$uccurr = "";
	$trans1 = "";
	$trans2 = "";

	chomp;
	$linje = $_;
	@felt = split ";", $linje;
	$corr = $felt[1];		#ortografi
	$decomp = $felt[2];		#dekomponering
	$pos = $felt[3];
	$decpos = $felt[4];
	$trans = $felt[11];
	$id = $felt[40];
	@ortledd = split /\+/, $decomp;		#hvert dekomponeringsledd

	if (($pos =~ /^(ng|np|nc)/) && ($decomp !~ /[_\-\']/) && ($decomp !~ /(veien|haugen|vegen|gata|gaten|bakken|moen|grenda)$/)) {
#print LOGG "New entry:\t$corr\t$decomp\n";
		$item = "$code"."\t$corr"."\t$trans"."\t$decomp"."\t$trans"."\t$pos"."\t$decomp"."\t$id";
		$longlist{$corr} = $item;
	}
	

#print LOGG "--------------\n";

}

foreach $key (sort keys %longlist) {
	print OUT "$longlist{$key}\n";
}
