#!usr/bin/perl

open IN1, "block_tnm_ch.lex";
open IN2, "block_tnm_ch_addon.lex";
open OUT, ">merged.lex";

%leddhash = "";

while (<IN2>) {
	chomp;
	$linje = $_;
	($item, $decomp, $orgtrans) = split /\t/, $linje;
	$leddhash{$item} = "$item"."\t$decomp"."\t$orgtrans";
}

while (<IN1>) {
	chomp;
	$line = $_;
	($word, $decomp, $orgtrans) = split /\t/, $line;
	unless (exists ($leddhash{$word})) {
		print OUT "$line\n";
	}
}
