#!perl -w

my $no_kons = "[bcdfghjklmnpqrstvwxz]";

my @no_ok2el = qw(
r
by
ur
is
bu
fe
l
ku
k
la
te
ro
y
al
s
l
bo
ed
hi
ri
se
gi
ve
ny
le
li
t
ly
mo
si
k
os
r
lo
ga
h
ry
g
sy
yr
m
p
ol
sa
ta
);
my $no_ok2el = join "|",@no_ok2el;

my @no_ok3el = qw(
tid
hus
lag
dag
bok
rom
rd
ls
ml
fri
liv
sak
tur
dyr
bt
fag
del
lov
vei
ord
tre
veg
lys
bil
lp
mat
rr
tak
fly
tal
ben
ln
vr
tap
kar
tog
vin
rot
syn
fot
rik
sko
ovn
bl
par
tro
sal
dr
ty
art
rd
ost
vev
syk
fr
lyd
ls
dd
rop
bad
lue
hol
omn
mel
sag
hr
ski
kor
duk
mor
sum
ved
gr
far
fr
nd
sr
bud
nl
egg
br
bro
fat
re
ull
hud
bru
uke
tru
kl
kur
orm
bit
sky
mur
gir
dom
sm
dam
bar
avl
lk
rev
sti
lek
and
gud
ild
ye
rus
sn
gul
re
eid
tyv
tau
mus
ras
arm
ark
lus
rem
bue
sol
vt
arv
lei
dp
ks
hav
tt
lr
urt
eld
eie
sau
bot
hr
not
bor
lim
ya
bol
bom
nd
myr
fil
bod
hue
dal
fyr
sus
akt
ris
gal
rs
hai
ape
ra
eng
lut
lt
rim
lav
kam
hg
lem
dyp
gs
jag
lv
dur
mot
god
hat
kum
tom
ran
st
elv
mil
lam
fl
due
pil
hy
fr
klo
sk
kr
hp
pol
st
ert
ror
ren
onn
tun
bua
sur
eik
rug
hl
bl
kt
bag
los
bed
fut
nr
dd
kos
bur
rad
fra
bie
dis
tue
bye
ham
bre
kol
sl
jus
kok
lr
br
vek
hyl
lur
mos
pop
var
sel
vis
ros
kyr
sj
sl
id
kis
pus
sug
sex
fin
st
uka
ulv
vid
st
vie
log
jul
gis
gym
sd
ung
rk
lg
ess
rn
mei
gav
kil
sid
sig
se
vk
nav
lua
pai
nek
fet
nag
uro
lyn
kle
kli
vom
myk
cup
for
mas
ky
bak
bas
spe
ulk
kai
spy
auk
dop
til
lik
ura
kve
riv
sli
slo
boa
bl
vd
la
ve
egd
sly
gy
vak
sj
vov
gro
von
val
ds
ans
roe
de
smi
mit
sys
ts
fr
syr
dun
len
rov
nem
duo
gny
sei
sne
hov
osp
sm
kik
gr
hk
led
yre
tua
my
gap
pl
glo
hei
nei
rye
vri
bs
fik
nid
fr
rip
alv
aks
isa
ask
pek
orv
tut
vr
odd
bys
pen
lia
hug
le
asp
jet
jef
by
kro
vik
gry
tr
bl
bk
tas
sl
rep
ide
kre
flo
gys
lot
lom
hit
);
my $no_ok3el = join "|",@no_ok3el;

my @no_ok2fl = qw(
by
is
ut
bo
ny
to
r
en
p
om
l
ti
av
ku
r
te
bu
y
k
sy
g
bi
ro
s
ur
el
ni
t
fe
ho
ja
il
d
s
tv
fy
da
do
li
lo
ed
it
et
ul
m
le
vm
ad
hi
nm
ef
t
al
fn
ne
em
h
pc
in
n
ks
ip
ml
at
eu
dy
cd
);
my $no_ok2fl = join "|",@no_ok2fl;

my @no_ok3fl = qw(
sm
fly
fag
sj
bil
inn
hus
tre
mat
fri
fot
ski
bok
lys
sol
hy
lov
bt
lyd
rs
sn
opp
vei
hav
nd
lav
vr
ml
bak
sr
ord
rom
vin
dag
vr
ned
veg
hel
vel
sr
bl
del
tog
lag
st
gr
tak
rd
lg
tur
fem
hr
nr
fin
fr
ute
ild
ls
hg
dr
ye
re
liv
gen
rus
bom
syd
rov
ben
eld
bar
ung
ved
dom
dyp
ull
mur
hud
rd
lik
rr
bly
rot
arm
uke
elg
sag
ene
lyn
egg
re
ide
lv
fyr
bue
mot
kne
sel
bre
sko
dd
pop
bro
fr
hr
br
cup
bud
mai
vt
sak
fra
tyv
hol
mer
gul
kor
lk
god
dal
lr
dam
sen
los
tau
lr
dun
sky
ren
ett
pol
buk
id
mor
lin
kol
ror
br
st
fir
re
ln
tal
myr
ras
gro
dau
gym
fr
far
kam
rk
sju
kur
jus
tet
fil
par
jet
vid
ris
sur
st
ape
vev
kl
uro
eks
sot
sd
sal
glo
ake
le
bek
leg
tid
hul
hit
sex
gud
syk
bru
sp
not
til
tro
due
sne
ens
kar
kr
kai
sil
gir
tom
ty
eng
lek
sr
smi
sed
akt
bor
hiv
kim
nei
lat
mus
lim
dyr
web
syv
de
syl
nid
dv
edb
sei
nl
jod
med
ls
bl
siv
bur
tam
aur
fet
lok
dop
mr
gra
tr
kok
hn
snu
kro
lut
pai
dum
hov
eds
hl
lt
let
die
pil
sau
rim
bas
jak
hen
ulv
dd
agn
jeg
jul
rug
hun
svi
led
rik
val
gs
vis
and
ane
lj
all
eie
mil
dur
ham
lus
han
nes
hos
lur
von
gal
vri
bys
dra
hat
nav
kl
sev
tun
ver
kum
fal
non
klo
aks
tru
eid
myk
fl
mys
bad
irr
syn
ovn
eke
age
hei
hor
vas
bs
ks
ton
ram
yte
pen
amt
alt
ore
men
kik
ete
orm
gru
tut
mel
hai
orr
gas
hak
mas
wat
bob
ve
bod
bog
mk
ky
mig
bol
sm
sti
bon
eir
old
bos
roe
juv
jur
vgn
rev
rn
zen
ros
ret
nd
se
aha
bus
gap
rem
rek
kr
ova
tg
ess
mr
gj
arv
bag
ego
pal
hp
hs
lam
van
uer
dis
les
mj
uni
vat
nat
tie
sys
flo
byg
bit
sas
don
rak
her
tr
ful
het
spe
fis
hev
www
sl
ecu
rib
pep
sid
fat
ill
pub
huk
fan
sve
vov
id
fn
vip
vor
nox
vom
kle
amo
kli
bnp
sub
fou
hal
);
my $no_ok3fl = join "|",@no_ok3fl;


sub postfix {
	my $dec = shift;
	$dec = fix_dec_el($dec);
	$dec = fix_fl_1_char($dec);
	$dec = fix_dec_fl($dec);
	$dec = fix_fl_2_char($dec);
	$dec = fix_fl_3_char($dec);
	$dec = fix_ml_2_char($dec);
#	$dec = fix_fl_2_char($dec);
	
	return $dec;
}


sub fix_dec_el {
	my $dec = shift;

	# fix one-letter el. Only accept 'i' and ''. Remove leading boundarie mark(s) in other cases
	$dec =~ s/\++(.)$/$1/;
	
	# fix two-letter el. First, do not accept consonant sequences. (This is no longer nescessary...)
	$dec =~ s/\++($no_kons+)$/$1/;

	# Only accept listed 2-letter endings from @sw_ok2el
	$dec =~ s/\++(..)$/$1/ if $dec !~ /\+($no_ok2el)$/;
	
	# fix three-letter el. Only accept listed 3-letter endings from @sw_ok3el
	$dec =~ s/\++(...)$/$1/ if $dec !~ /\+($no_ok3el)$/;

	return $dec;	
}

sub fix_dec_fl {
	my $dec = shift;
	
	# 'fix' linking s. Many will still be appended incorrectly. Snyft...
	$dec =~ s/(s\+s)\+([^s])/$1$2/g;
	$dec =~ s/([^s])\+(s\+s)/$1$2/g;
	$dec =~ s/\+s\+/s\+/g;
	
	return $dec;
}

sub fix_fl_1_char {
	my $dec = shift;
	# 1-letter fl. Only accept i o 
	$dec =~ s/^([^i])\+/$1/g;
	return $dec;
}

sub fix_fl_2_char {
	my $dec = shift;

	# Only accept listed 2-letter fl from @no_ok2fl
	$dec =~ s/^(..)\++/$1/ if $dec !~ /^($no_ok2fl)\+/;
#	print "$dec\n$dec-\-\>";

	return $dec;
}

sub fix_fl_3_char {
	my $dec = shift;

	# Only accept listed 3-letter fl from @no_ok3fl
	$dec =~ s/^(...)\++/$1/ if $dec !~ /^($no_ok3fl)\+/;
#	print "$dec\n$dec-\-\>";

	return $dec;
}

sub fix_ml_2_char {
	my $dec = shift;

	# -be- and -re- -de- always collapsed with el. -me- -se- most often
	$dec =~ s/(\+[mrbds]e)\+/$1/g;

	# -by-
	$dec =~ s/(\+by)\+((r|gg|gd|s)[^d])/$1$2/g;

	# -te- with fl most often (5 of 7 times)
	$dec =~ s/\+([t]e\+)/$1/g;

	# -in- with el most often (not tein/rein/otin)
	$dec =~ s/(te|re|ot)\+(in\+)/$1$2/g;
	$dec =~ s/(\+[ia]n)\+/$1/g;
	
	# -av- to el
	$dec =~ s/(\+av)\+/$1/g;

	# -ve- to fl. some exceptions
	$dec =~ s/(\+ve)\+(sen|ske|ving|str)/$1$2/g;
	$dec =~ s/\+(ve\+)/$1/g;

	return $dec;
}

1;


__END__



s	1424	169	8
r	218	18
e	157	18
t	122	10
l	102	16
g	73
n	70	10
k	65
f	36
o	35
v	29
m	28
d	20
a	14
p	10
i	9
	4
	1
b	1
h	1




s	169
r	18
e	18
l	16
t	10
n	10
k	9
v	5
g	4
a	2
h	1
	1
d	1
m	1
f	1
o	1



s	8





2ml:

<se	64
<in	64
<an	55
<av	52
<ve	49
ar	49
fe	49
le	45
al	37
st	37
n	34
ut	32
pe	30
om	24
ge	23
l	23
ne	22
er	21
ka	19
s	18
gg	17
ad	16
is	16
r	15
el	12
lo	12
ko	11
ce	10
p	8
r	7
he	7
ke	7
ti	7
at	7
en	6
b	6
la	6
ur	6
bo	6
us	6
lm	5
ri	5
h	5
au	5
im	5
em	5
ds	4
bl	4
mi	4
pa	4
r	4
ga	4
m	4
un	4
ul	4
fa	3
ok	3
on	3
p	3
ps	3
fn	3
n	3
ol	3
vi	3
ba	3
sk	3
di	3
m	2
ra	2
br	2
as	2
bu	2
ro	2
gi	2
kn	2
ma	2
or	2
ig	2
os	2
ha	2
t	2
ue	2
ht	2
ye	2
vy	1
ie	1
ru	1
if	1
rn	1
f	1
ta	1
nk	1
r	1
va	1
ni	1
fi	1
pi	1
je	1
d	1
da	1
dy	1
sn	1
ls	1
s	1
pr	1
so	1
kk	1
sa	1
ts	1
it	1
id	1
iv	1


OK 3ml i facit

rs	146
hus	105
dyr	58
bok	41
bil	39
rd	25
fot	22
cup	21
lov	21
fly	18
bt	18
fag	17
br	17
ord	16
hy	16
hg	15
mor	11
tog	10
tre	10
vei	9
mat	7
lk	6
dom	5
st	5
del	5
fri	5
rot	5
tur	5
mai	4
rr	4
lys	4
inn	4
kl	4
fr	3
kol	3
ski	3
sak	3
dag	3
sj	3
ned	3
sn	3
veg	3
tal	2
sau	2
ark	2
ty	2
not	2
hiv	2
far	2
kor	2
sko	2
fr	2
sol	2
lv	2
mel	2
ye	2
kar	2
arm	2
ved	2
bit	1
hav	1
nr	1
ovn	1
jet	1
bar	1
vr	1
re	1
opp	1
sm	1
var	1
gs	1
seg	1
sal	1
amt	1
god	1
re	1
lus	1
bad	1
ost	1
bue	1
bak	1
orm	1
