#!/usr/bin/perl

use locale;
use POSIX 'locale_h';
setlocale(LC_CTYPE,$locale{Norwegian});

#open IN, "L:\\LEXWORKS_DEVELOPMENT\\G2P_LIGHT\\SW\\PREPARE\\sw_trk_100k.dic";
#open OUT, ">sw_trk_100k_g2pl_compare.OUT";

open IN, "rest_rand.dic";
open OUT, ">rand_rest_g2pl_compare.OUT";

require 'L:\\LEXWORKS_DEVELOPMENT\\G2P_LIGHT\\SW\\sw_g2p_light.pl';

$tot = 0;
$ok = 0;
	
while (<IN>) {
	chomp;
	($item, $orgtrans) = split /\t/, $_;
	($wd,$dec,$trk) = &g2p_light($item);
	$trk =~ s/(_ |_)//g;
	$trk =~ s/ $//;
	if ($trk eq $orgtrans) {
		print OUT "LIKE:$item\t$trk\t$orgtrans\t$dec\n";
		$ok++;
		$tot++;
	}
	else {
		print OUT "ULIKE:$item\t$trk\t$orgtrans\t$dec\n";
		$tot++;
	}	
} # end while


$pcnt = int(($ok/$tot)*100);

print STDOUT "OK:   $ok\nTOT:   $tot\nPCNT:   $pcnt\n";

sleep 1000;



