#!usr/bin/perl

#Universal variables required for Norwegian decomposition tool

##########################################################################################

$uc = '[A-Z]';
$lc = '[a-z]';
$vow = 'a|e|i|o|u|y||||||||||||';
$con = 'b|c|d|f|g|h|j|k|l|m|n|p|q|r|s|t|v|w|x|z|||';
$con_no_s = 'b|c|d|f|g|h|j|k|l|m|n|p|q|r|t|v|w|x|z|||';
$db_con = 'bb|dd|ff|gg|kk|ll|mm|nn|pp|rr|ss|tt|zz';

$init = 'bj|bl|br|chr|ch|cr|dj|dr|dv|fj|fl|fn|fr|gj|gl|gn|gr|hj|hv|kj|kl|kn|kr|kv|mj|pj|pl|pr|skj|skl|skr|skv|sk|spj|spl|spr|sp|stj|str|st|sj|sl|sm|sn|sv|tj|tr|tv|vr';
$fin = 'ld|rd|nd|gd|vd|rg|lg|ngst|ngs|ng|rsk|lsk|nsk|sk|gl|lm|rm|gn|rn|rs|vn|rp|lp|mp|sp|gs|ns|ks|rs|ls|ms|lst|rst|kst|mst|st|ft|gt|nkt|kt|lt|mt|nt|pt|rt|lv|lj';
$scls = 'kr|pr|k';
          
$legal = $init.'|'.$fin;

#legg til suff??: -ikk, rmvd -tiv (avstiving), rmvd -ist (gjerningskristendom)
$suffix = 'sjonr|isme|ment|het|nad|sjon|dom|else|ende|itet|skap|som|ering|ning|aktig|messig|stendig|hjertig|verdig|ferdig|landsk|lending|lender|ling|ing|selig|sel|lig|aktig|messig|haftig|tydig|foldig|dig|isk|ial';
$suffix_u_s = 'isme|anse|som|selig|lig|aktig|messig|stendig|hjertig|verdig|ferdig|dig|isk|landsk|lending|ansk|ial';
$prefix = 'ved|unn|mot|dys|ad|an|uten|om|hen|all|sammen|sam|gjen|til|av|be|opp|ut|fore|for|med|mis|under|inn|ned|over|fram|frem';
#adding gjen- and til- as prefixes, also adding sam- and om-
#not using bak as prefix

$inflection = 'ene|ne|en|et|ere|er|re|este|est|ste|st|t|te|e|a|\'s|s';

$two_letter_roots = 'av|bo|bu|by|b|ed|en|f|gi|g|hi|is|ku|k|la|ly|mo|m|ny|om|p|ro|r|sy|to|ur|ut|yr|l|r|s|k|l|y';

#items which, when followed by s$ do not have the s stripped. 
$no_s_strip = 'intelligen|blit|tilfred|han|annek|link|kvart|ert|rik|sek|fik|konden|ver|aid|aksiden|bakleng|br|eksisten|korp|god|hal|kor|odd|ressur';


##########################################################################################

#$s_initial = "skjr|skratt|strek|skrekk|skatt|skje|skjerm|skjr|skrap|skrev|skrift|skrik|skript|skriv|sted|stoff|strid|stripp|stykke";

$skj_initial = 'skje$|skjede|skjefte|skjegg|skjelett|skjell|skjelv|skjema|skjemt|skjend|skjenk|skjerf|skjerm|skjev|skjold|skjorte|skjul|skjnn|skjr|skjrt|skjt';
$skr_initial = 'skranke|skrape|skratt|skred|skrei|skrekk|skrell|skrem|skreve|skribent|skrift|skrik|skrin|skriptum|skritt|skriv|skrott|skru|skr|skrne';
$skv_initial = 'skvadron|skvald|skvale|skvaller|skvalp|skvatre|skvett|skvip|skvis|skvulp|skvr';
$spj_initial = 'spjeld|spjelk|spjert|spjette|spjke|spjl|spjre';
$spl_initial = 'spleis|splid|splint|splitt';
$spr_initial = 'skjorte|skred|skjul|sprade|spragle|sprak|sprang|spray|spred|spreie|sprek|sprell|sprelsk|spreng|sprett|sprik|spring|sprinkel|sprinkle|sprint|sprit|sprosse|sprudle|sprukken|sprunge|sprut|sprk|spr';
$stj_initial = 'stjele|stjerne|stjerna|stjert|stjal|stjle';
$str_initial = 'strabas|stradivarius|straff|strak|stram|strand|strange|strateg|stratifi|strato|stratt|stratum|stratus|strebe|strede|streif|streik|streit|strek|strende|strene|streng|strepto|stress|stretch|strete|strev|stri|strof|stroke|stropp|strosse|struktur|struma|strunk|strupe|struts|strutt|stryk|strype|str|str';

#$skl_initial 'sklero|sklie'; #don't use this, too rare, list in full_compound instead if they turn up

##########################################################################################

sub init_vars {
# Variables initiated for each word. 

	$init_cap = 0;
	return;
} #end sub

1;
