#! perl -w

## Filename:	no_parsing_parameters.pl
## Author:		Sofia Strmbergsson
## Date:		000405
##
## Description:	Parsing parameters used by Norwegian parser.


# name of input file
#$INFILE = "no_test.txt";
#$INFILE = "test-leksikon.txt";
#$INFILE = "all_lists_rev82.parsed";

$INFILE = "bedr_flatfil";

$OUTFILE = "$INFILE.parsed";

$NICE_OUTPUT = 1;				# set to 1 if the output should pretty, if 0: input line is not changed

#$SELECTION_OF_TRANSCRIPTIONS = 'enter_se|spd_se';	# if underspecified, replace with ''
#$SELECTION_OF_TRANSCRIPTIONS = '';		# if underspecified, replace with ''

$SELECTION_OF_TRANSCRIPTIONS = '.*';		# if underspecified, replace with '.*'
$VALUE_FOR_GARBAGE = 0;			# if underspecified, replace with (0|1)

# Choose which errors to search for(1=yes, 0=no):
# Error messages:
$E_PERIOD_LAST = 1;
$E_ILLEGAL_NOR_SYMBOL = 1;
$E_ILL_FORMED_DIACRITIC = 1;
$E_NOF_UNDERSCORES = 0;
$E_NO_NUCLEUS = 1;
$E_TOO_MANY_NUCLEI = 1;
$E_ILLEGAL_STRESS_PATTERN = 0;
$E_UNWANTED_SEQUENCE = 1;
$E_NOT_NOR_ONSET = 1;
$E_ONSET_NOT_INITIALLY = 1;
$E_NOT_NOR_CODA = 1;
$E_MOP_VIOLATION = 1;

# Warnings:
$W_UNWANTED_DUPLICATION = 1;
$W_UNWANTED_SEQUENCE = 0;
$W_ORTOGRAPHIC_CORRESPONDENCE = 1;
$W_SIMPLEX_WITH_SEC_STRESS = 0;
$W_RARE_NOR_CODA = 0;
$W_RARE_NOR_ONSET = 0;
$W_MOP_VIOLATION = 0;
$W_NOT_GEMINATE_CONS = 1;
$W_LANG_CORRESPONDENCE = 1;

1;	# return 1 to parser-file