#!perl

%map = qw(
151	E&U0
153	E+&Y
930	n+%\)
940	l+%\)
152	E&I
154	A&I
155	O&I
190	t&S
910	n%\)
920	l%\)
050	u0:
090	e+:
010	A:
020	e:
030	i:
040	u:
060	y:
070	o:
081	@:
221	U0
091	E+
100	d+
110	t+
130	n+
140	l+
400	nK
421	r6
510	2'
520	'2
181	A
200	I
210	U
230	Y
240	O
250	E
270	b
280	d
290	g
300	p
310	t
320	k
330	f
340	s
341	S
360	V
370	C
380	m
390	n
410	l
430	h
440	j
500	'
530	.
550	_
570	"
);



@il_onsets = qw(
x340x300x421
x340x300x410
x340x300x440
x340x310x421
x340x310x440
x340x320x360
x340x320x421
x340x320x410
x300x421
x300x410
x300x440
x270x421
x270x410
x270x440
x310x421
x310x360
x310x440
x280x360
x280x440
x280x421
x320x390
x320x360
x320x421
x320x410
x290x390
x290x421
x290x410
x380x440
x390x440
x330x390
x330x421
x330x410
x330x440
x360x421
x340x300
x340x310
x340x320
x340x380
x340x390
x340x330
x340x360
x340x410
x341x310
x341x320
x341x410
x300
x270 
x310
x280
x320
x290
x380
x390 
x330
x360
x421
x340
x341
x370
x430
x410
x440
x100
x110
x130
x140
x190
);


%MORF_DESCR = qw(
	0n	proper-noun-nom
	0g	proper-noun-gen

	1	sing-indef-nom-masc-Neutral
	2	sing-def-nom-masc-Neutral
	3	plur-indef-nom-masc-Neutral
	4	plur-def-nom-masc-Neutral
	5	sing-indef-gen-masc-Neutral
	6	sing-def-gen-masc-Neutral
	7	plur-indef-gen-masc-Neutral
	8	plur-def-gen-masc-Neutral

	11	sing-indef-nom-fem-Neutral
	12	sing-def-nom-fem-Neutral
	13	plur-indef-nom-fem-Neutral
	14	plur-def-nom-fem-Neutral
	15	sing-indef-gen-fem-Neutral
	16	sing-def-gen-fem-Neutral
	17	plur-indef-gen-fem-Neutral
	18	plur-def-gen-fem-Neutral

	21	sing-indef-nom-neu-Neutral
	22	sing-def-nom-neu-Neutral
	23	plur-indef-nom-neu-Neutral
	24	plur-def-nom-neu-Neutral
	25	sing-indef-gen-neu-Neutral
	26	sing-def-gen-neu-Neutral
	27	plur-indef-gen-neu-Neutral
	28	plur-def-gen-neu-Neutral

	1a	sing-indef-nom-masc-Neutral-Sideform_a
	2a	sing-def-nom-masc-Neutral-Sideform_a
	3a	plur-indef-nom-masc-Neutral-Sideform_a
	4a	plur-def-nom-masc-Neutral-Sideform_a
	5a	sing-indef-gen-masc-Neutral-Sideform_a
	6a	sing-def-gen-masc-Neutral-Sideform_a
	7a	plur-indef-gen-masc-Neutral-Sideform_a
	8a	plur-def-gen-masc-Neutral-Sideform_a

	11a	sing-indef-nom-fem-Neutral-Sideform_a
	12a	sing-def-nom-fem-Neutral-Sideform_a
	13a	plur-indef-nom-fem-Neutral-Sideform_a
	14a	plur-def-nom-fem-Neutral-Sideform_a
	15a	sing-indef-gen-fem-Neutral-Sideform_a
	16a	sing-def-gen-fem-Neutral-Sideform_a
	17a	plur-indef-gen-fem-Neutral-Sideform_a
	18a	plur-def-gen-fem-Neutral-Sideform_a

	21a	sing-indef-nom-neu-Neutral-Sideform_a
	22a	sing-def-nom-neu-Neutral-Sideform_a
	23a	plur-indef-nom-neu-Neutral-Sideform_a
	24a	plur-def-nom-neu-Neutral-Sideform_a
	25a	sing-indef-gen-neu-Neutral-Sideform_a
	26a	sing-def-gen-neu-Neutral-Sideform_a
	27a	plur-indef-gen-neu-Neutral-Sideform_a
	28a	plur-def-gen-neu-Neutral-Sideform_a

	1b	sing-indef-nom-masc-Neutral-Sideform_b
	2b	sing-def-nom-masc-Neutral-Sideform_b
	3b	plur-indef-nom-masc-Neutral-Sideform_b
	4b	plur-def-nom-masc-Neutral-Sideform_b
	5b	sing-indef-gen-masc-Neutral-Sideform_b
	6b	sing-def-gen-masc-Neutral-Sideform_b
	7b	plur-indef-gen-masc-Neutral-Sideform_b
	8b	plur-def-gen-masc-Neutral-Sideform_b

	11b	sing-indef-nom-fem-Neutral-Sideform_b
	12b	sing-def-nom-fem-Neutral-Sideform_b
	13b	plur-indef-nom-fem-Neutral-Sideform_b
	14b	plur-def-nom-fem-Neutral-Sideform_b
	15b	sing-indef-gen-fem-Neutral-Sideform_b
	16b	sing-def-gen-fem-Neutral-Sideform_b
	17b	plur-indef-gen-fem-Neutral-Sideform_b
	18b	plur-def-gen-fem-Neutral-Sideform_b

	21b	sing-indef-nom-neu-Neutral-Sideform_b
	22b	sing-def-nom-neu-Neutral-Sideform_b
	23b	plur-indef-nom-neu-Neutral-Sideform_b
	24b	plur-def-nom-neu-Neutral-Sideform_b
	25b	sing-indef-gen-neu-Neutral-Sideform_b
	26b	sing-def-gen-neu-Neutral-Sideform_b
	27b	plur-indef-gen-neu-Neutral-Sideform_b
	28b	plur-def-gen-neu-Neutral-Sideform_b

	1c	sing-indef-nom-masc-Neutral-Sideform_c
	2c	sing-def-nom-masc-Neutral-Sideform_c
	3c	plur-indef-nom-masc-Neutral-Sideform_c
	4c	plur-def-nom-masc-Neutral-Sideform_c
	5c	sing-indef-gen-masc-Neutral-Sideform_c
	6c	sing-def-gen-masc-Neutral-Sideform_c
	7c	plur-indef-gen-masc-Neutral-Sideform_c
	8c	plur-def-gen-masc-Neutral-Sideform_c

	11c	sing-indef-nom-fem-Neutral-Sideform_c
	12c	sing-def-nom-fem-Neutral-Sideform_c
	13c	plur-indef-nom-fem-Neutral-Sideform_c
	14c	plur-def-nom-fem-Neutral-Sideform_c
	15c	sing-indef-gen-fem-Neutral-Sideform_c
	16c	sing-def-gen-fem-Neutral-Sideform_c
	17c	plur-indef-gen-fem-Neutral-Sideform_c
	18c	plur-def-gen-fem-Neutral-Sideform_c

	21c	sing-indef-nom-neu-Neutral-Sideform_c
	22c	sing-def-nom-neu-Neutral-Sideform_c
	23c	plur-indef-nom-neu-Neutral-Sideform_c
	24c	plur-def-nom-neu-Neutral-Sideform_c
	25c	sing-indef-gen-neu-Neutral-Sideform_c
	26c	sing-def-gen-neu-Neutral-Sideform_c
	27c	plur-indef-gen-neu-Neutral-Sideform_c
	28c	plur-def-gen-neu-Neutral-Sideform_c

	1R	sing-indef-nom-masc-Radical
	2R	sing-def-nom-masc-Radical
	3R	plur-indef-nom-masc-Radical
	4R	plur-def-nom-masc-Radical
	5R	sing-indef-gen-masc-Radical
	6R	sing-def-gen-masc-Radical
	7R	plur-indef-gen-masc-Radical
	8R	plur-def-gen-masc-Radical

	11R	sing-indef-nom-fem-Radical
	12R	sing-def-nom-fem-Radical
	13R	plur-indef-nom-fem-Radical
	14R	plur-def-nom-fem-Radical
	15R	sing-indef-gen-fem-Radical
	16R	sing-def-gen-fem-Radical
	17R	plur-indef-gen-fem-Radical
	18R	plur-def-gen-fem-Radical

	21R	sing-indef-nom-neu-Radical
	22R	sing-def-nom-neu-Radical
	23R	plur-indef-nom-neu-Radical
	24R	plur-def-nom-neu-Radical
	25R	sing-indef-gen-neu-Radical
	26R	sing-def-gen-neu-Radical
	27R	plur-indef-gen-neu-Radical
	28R	plur-def-gen-neu-Radical

	1Ra	sing-indef-nom-masc-Radical-Sideform_a
	2Ra	sing-def-nom-masc-Radical-Sideform_a
	3Ra	plur-indef-nom-masc-Radical-Sideform_a
	4Ra	plur-def-nom-masc-Radical-Sideform_a
	5Ra	sing-indef-gen-masc-Radical-Sideform_a
	6Ra	sing-def-gen-masc-Radical-Sideform_a
	7Ra	plur-indef-gen-masc-Radical-Sideform_a
	8Ra	plur-def-gen-masc-Radical-Sideform_a

	11Ra	sing-indef-nom-fem-Radical-Sideform_a
	12Ra	sing-def-nom-fem-Radical-Sideform_a
	13Ra	plur-indef-nom-fem-Radical-Sideform_a
	14Ra	plur-def-nom-fem-Radical-Sideform_a
	15Ra	sing-indef-gen-fem-Radical-Sideform_a
	16Ra	sing-def-gen-fem-Radical-Sideform_a
	17Ra	plur-indef-gen-fem-Radical-Sideform_a
	18Ra	plur-def-gen-fem-Radical-Sideform_a

	21Ra	sing-indef-nom-neu-Radical-Sideform_a
	22Ra	sing-def-nom-neu-Radical-Sideform_a
	23Ra	plur-indef-nom-neu-Radical-Sideform_a
	24Ra	plur-def-nom-neu-Radical-Sideform_a
	25Ra	sing-indef-gen-neu-Radical-Sideform_a
	26Ra	sing-def-gen-neu-Radical-Sideform_a
	27Ra	plur-indef-gen-neu-Radical-Sideform_a
	28Ra	plur-def-gen-neu-Radical-Sideform_a

	1A	sing-indef-nom-masc-Archaic
	2A	sing-def-nom-masc-Archaic
	3A	plur-indef-nom-masc-Archaic
	4A	plur-def-nom-masc-Archaic
	5A	sing-indef-gen-masc-Archaic
	6A	sing-def-gen-masc-Archaic
	7A	plur-indef-gen-masc-Archaic
	8A	plur-def-gen-masc-Archaic

	11A	sing-indef-nom-fem-Archaic
	12A	sing-def-nom-fem-Archaic
	13A	plur-indef-nom-fem-Archaic
	14A	plur-def-nom-fem-Archaic
	15A	sing-indef-gen-fem-Archaic
	16A	sing-def-gen-fem-Archaic
	17A	plur-indef-gen-fem-Archaic
	18A	plur-def-gen-fem-Archaic

	21A	sing-indef-nom-neu-Archaic
	22A	sing-def-nom-neu-Archaic
	23A	plur-indef-nom-neu-Archaic
	24A	plur-def-nom-neu-Archaic
	25A	sing-indef-gen-neu-Archaic
	26A	sing-def-gen-neu-Archaic
	27A	plur-indef-gen-neu-Archaic
	28A	plur-def-gen-neu-Archaic

	1C	sing-indef-nom-masc-Casual
	2C	sing-def-nom-masc-Casual
	3C	plur-indef-nom-masc-Casual
	4C	plur-def-nom-masc-Casual
	5C	sing-indef-gen-masc-Casual
	6C	sing-def-gen-masc-Casual
	7C	plur-indef-gen-masc-Casual
	8C	plur-def-gen-masc-Casual

	11C	sing-indef-nom-fem-Casual
	12C	sing-def-nom-fem-Casual
	13C	plur-indef-nom-fem-Casual
	14C	plur-def-nom-fem-Casual
	15C	sing-indef-gen-fem-Casual
	16C	sing-def-gen-fem-Casual
	17C	plur-indef-gen-fem-Casual
	18C	plur-def-gen-fem-Casual

	21C	sing-indef-nom-neu-Casual
	22C	sing-def-nom-neu-Casual
	23C	plur-indef-nom-neu-Casual
	24C	plur-def-nom-neu-Casual
	25C	sing-indef-gen-neu-Casual
	26C	sing-def-gen-neu-Casual
	27C	plur-indef-gen-neu-Casual
	28C	plur-def-gen-neu-Casual

	1K	sing-indef-nom-masc-Klammeform
	2K	sing-def-nom-masc-Klammeform
	3K	plur-indef-nom-masc-Klammeform
	4K	plur-def-nom-masc-Klammeform
	5K	sing-indef-gen-masc-Klammeform
	6K	sing-def-gen-masc-Klammeform
	7K	plur-indef-gen-masc-Klammeform
	8K	plur-def-gen-masc-Klammeform

	11K	sing-indef-nom-fem-Klammeform
	12K	sing-def-nom-fem-Klammeform
	13K	plur-indef-nom-fem-Klammeform
	14K	plur-def-nom-fem-Klammeform
	15K	sing-indef-gen-fem-Klammeform
	16K	sing-def-gen-fem-Klammeform
	17K	plur-indef-gen-fem-Klammeform
	18K	plur-def-gen-fem-Klammeform

	21K	sing-indef-nom-neu-Klammeform
	22K	sing-def-nom-neu-Klammeform
	23K	plur-indef-nom-neu-Klammeform
	24K	plur-def-nom-neu-Klammeform
	25K	sing-indef-gen-neu-Klammeform
	26K	sing-def-gen-neu-Klammeform
	27K	plur-indef-gen-neu-Klammeform
	28K	plur-def-gen-neu-Klammeform

	101	pos-sing-indef-nom-masc_fem-Neutral
	102	pos-sing-indef-nom-neu-Neutral
	103	pos-plur-indef-nom-Neutral
	104	pos-sing_plur-def-nom-Neutral
	105	komp-sing_plur-nom-Neutral
	106	sup-sing-indef-nom-Neutral
	107	sup-sing-def-nom-Neutral
	108	sup-plur-nom-Neutral
	109	pos-sing-indef-gen-masc_fem-Neutral
	110	pos-sing-indef-gen-neu-Neutral
	111	pos-plur-indef-gen-Neutral
	112	pos-sing_plur-def-gen-Neutral
	113	komp-sing_plur-gen-Neutral
	114	sup-sing-indef-gen-Neutral
	115	sup-sing-def-gen-Neutral
	116	sup-plur-gen-Neutral

	101m	pos-sing-indef-nom-masc-Neutral
	109m	pos-sing-indef-gen-masc-Neutral
	101f	pos-sing-indef-nom-fem-Neutral
	109f	pos-sing-indef-gen-fem-Neutral
	104p	pos-plur-def-nom-Neutral
	104s	pos-sing-def-nom-Neutral
	112p	pos-plur-def-gen-Neutral
	112s	pos-sing-def-gen-Neutral

	101mR	pos-sing-indef-nom-masc-Radical
	109mR	pos-sing-indef-gen-masc-Radical
	101fR	pos-sing-indef-nom-fem-Radical
	109fR	pos-sing-indef-gen-fem-Radical
	104pR	pos-plur-def-nom-Radical
	104sR	pos-sing-def-nom-Radical
	112pR	pos-plur-def-gen-Radical
	112sR	pos-sing-def-gen-Radical
	
	101a	pos-sing-indef-nom-masc_fem-Neutral-Sideform
	102a	pos-sing-indef-nom-neu-Neutral-Sideform
	103a	pos-plur-indef-nom-Neutral-Sideform
	104a	pos-sing_plur-def-nom-Neutral-Sideform
	105a	komp-sing_plur-nom-Neutral-Sideform
	106a	sup-sing-indef-nom-Neutral-Sideform
	107a	sup-sing-def-nom-Neutral-Sideform
	108a	sup-plur-nom-Neutral-Sideform
	109a	pos-sing-indef-gen-masc_fem-Neutral-Sideform
	110a	pos-sing-indef-gen-neu-Neutral-Sideform
	111a	pos-plur-indef-gen-Neutral-Sideform
	112a	pos-sing_plur-def-gen-Neutral-Sideform
	113a	komp-sing_plur-gen-Neutral-Sideform
	114a	sup-sing-indef-gen-Neutral-Sideform
	115a	sup-sing-def-gen-Neutral-Sideform
	116a	sup-plur-gen-Neutral-Sideform

	101R	pos-sing-indef-nom-masc_fem-Radical
	102R	pos-sing-indef-nom-neu-Radical
	103R	pos-plur-indef-nom-Radical
	104R	pos-sing_plur-def-nom-Radical
	105R	komp-sing_plur-nom-Radical
	106R	sup-sing-indef-nom-Radical
	107R	sup-sing-def-nom-Radical
	108R	sup-plur-nom-Radical
	109R	pos-sing-indef-gen-masc_fem-Radical
	110R	pos-sing-indef-gen-neu-Radical
	111R	pos-plur-indef-gen-Radical
	112R	pos-sing_plur-def-gen-Radical
	113R	komp-sing_plur-gen-Radical
	114R	sup-sing-indef-gen-Radical
	115R	sup-sing-def-gen-Radical
	116R	sup-plur-gen-Radical

	101K	pos-sing-indef-nom-masc_fem-Klammeform
	102K	pos-sing-indef-nom-neu-Klammeform
	103K	pos-plur-indef-nom-Klammeform
	104K	pos-sing_plur-def-nom-Klammeform
	105K	komp-sing_plur-nom-Klammeform
	106K	sup-sing-indef-nom-Klammeform
	107K	sup-sing-def-nom-Klammeform
	108K	sup-plur-nom-Klammeform
	109K	pos-sing-indef-gen-masc_fem-Klammeform
	110K	pos-sing-indef-gen-neu-Klammeform
	111K	pos-plur-indef-gen-Klammeform
	112K	pos-sing_plur-def-gen-Klammeform
	113K	komp-sing_plur-gen-Klammeform
	114K	sup-sing-indef-gen-Klammeform
	115K	sup-sing-def-gen-Klammeform
	116K	sup-plur-gen-Klammeform

	201	aktiv-infinitiv-Neutral
	202	aktiv-presens-Neutral
	203	aktiv-preteritum-Neutral
	204	aktiv-perfektum_partisipp-sing-indef-nom-Neutral
	205	aktiv-presens_partisipp-sing_plur-indef_def-nom-Neutral
	206	aktiv-presens_partisipp-sing_plur-indef_def-gen-Neutral
	207	aktiv-imperativ-Neutral
	208	passiv-infinitiv-Neutral
	209	passiv-presens-Neutral
	210	aktiv-perfektum_partisipp-sing-indef-gen-Neutral
	211	aktiv-perfektum_partisipp-sing-def-nom-Neutral
	212	aktiv-perfektum_partisipp-plur-def-nom-Neutral
	213	aktiv-perfektum_partisipp-sing-def-gen-Neutral
	214	aktiv-perfektum_partisipp-plur-def-gen-Neutral
	215	verbalsubstantiv-Neutral

	201a	aktiv-infinitiv-Sideform_a
	202a	aktiv-presens-Sideform_a
	203a	aktiv-preteritum-Sideform_a
	204a	aktiv-perfektum_partisipp-sing-indef-nom-Sideform_a
	205a	aktiv-presens_partisipp-sing_plur-indef_def-nom-Sideform_a
	206a	aktiv-presens_partisipp-sing_plur-indef_def-gen-Sideform_a
	207a	aktiv-imperativ-Sideform_a
	208a	passiv-infinitiv-Sideform_a
	209a	passiv-presens-Sideform_a
	210a	aktiv-perfektum_partisipp-sing-indef-gen-Sideform_a
	211a	aktiv-perfektum_partisipp-sing-def-nom-Sideform_a
	212a	aktiv-perfektum_partisipp-plur-def-nom-Sideform_a
	213a	aktiv-perfektum_partisipp-sing-def-gen-Sideform_a
	214a	aktiv-perfektum_partisipp-plur-def-gen-Sideform_a
	215a	verbalsubstantiv-Sideform_a

	201b	aktiv-infinitiv-Sideform_b
	202b	aktiv-presens-Sideform_b
	203b	aktiv-preteritum-Sideform_b
	204b	aktiv-perfektum_partisipp-sing-indef-nom-Sideform_b
	205b	aktiv-presens_partisipp-sing_plur-indef_def-nom-Sideform_b
	206b	aktiv-presens_partisipp-sing_plur-indef_def-gen-Sideform_b
	207b	aktiv-imperativ-Sideform_b
	208b	passiv-infinitiv-Sideform_b
	209b	passiv-presens-Sideform_b
	210b	aktiv-perfektum_partisipp-sing-indef-gen-Sideform_b
	211b	aktiv-perfektum_partisipp-sing-def-nom-Sideform_b
	212b	aktiv-perfektum_partisipp-plur-def-nom-Sideform_b
	213b	aktiv-perfektum_partisipp-sing-def-gen-Sideform_b
	214b	aktiv-perfektum_partisipp-plur-def-gen-Sideform_b
	215b	verbalsubstantiv-Sideform_b

	201c	aktiv-infinitiv-Sideform_c
	202c	aktiv-presens-Sideform_c
	203c	aktiv-preteritum-Sideform_c
	204c	aktiv-perfektum_partisipp-sing-indef-nom-Sideform_c
	205c	aktiv-presens_partisipp-sing_plur-indef_def-nom-Sideform_c
	206c	aktiv-presens_partisipp-sing_plur-indef_def-gen-Sideform_c
	207c	aktiv-imperativ-Sideform_c
	208c	passiv-infinitiv-Sideform_c
	209c	passiv-presens-Sideform_c
	210c	aktiv-perfektum_partisipp-sing-indef-gen-Sideform_c
	211c	aktiv-perfektum_partisipp-sing-def-nom-Sideform_c
	212c	aktiv-perfektum_partisipp-plur-def-nom-Sideform_c
	213c	aktiv-perfektum_partisipp-sing-def-gen-Sideform_c
	214c	aktiv-perfektum_partisipp-plur-def-gen-Sideform_c
	215c	verbalsubstantiv-Sideform_c

	201K	aktiv-infinitiv-Klammeform
	202K	aktiv-presens-Klammeform
	203K	aktiv-preteritum-Klammeform
	204K	aktiv-perfektum_partisipp-sing-indef-nom-Klammeform
	205K	aktiv-presens_partisipp-sing_plur-indef_def-nom-Klammeform
	206K	aktiv-presens_partisipp-sing_plur-indef_def-gen-Klammeform
	207K	aktiv-imperativ-Klammeform
	208K	passiv-infinitiv-Klammeform
	209K	passiv-presens-Klammeform
	210K	aktiv-perfektum_partisipp-sing-indef-gen-Klammeform
	211K	aktiv-perfektum_partisipp-sing-def-nom-Klammeform
	212K	aktiv-perfektum_partisipp-plur-def-nom-Klammeform
	213K	aktiv-perfektum_partisipp-sing-def-gen-Klammeform
	214K	aktiv-perfektum_partisipp-plur-def-gen-Klammeform
	215K	verbalsubstantiv-Klammeform

	201R	aktiv-infinitiv-Radical
	202R	aktiv-presens-Radical
	203R	aktiv-preteritum-Radical
	204R	aktiv-perfektum_partisipp-sing-indef-nom-Radical
	205R	aktiv-presens_partisipp-sing_plur-indef_def-nom-Radical
	206R	aktiv-presens_partisipp-sing_plur-indef_def-gen-Radical
	207R	aktiv-imperativ-Radical
	208R	passiv-infinitiv-Radical
	209R	passiv-presens-Radical
	210R	aktiv-perfektum_partisipp-sing-indef-gen-Radical
	211R	aktiv-perfektum_partisipp-sing-def-nom-Radical
	212R	aktiv-perfektum_partisipp-plur-def-nom-Radical
	213R	aktiv-perfektum_partisipp-sing-def-gen-Radical
	214R	aktiv-perfektum_partisipp-plur-def-gen-Radical
	215R	verbalsubstantiv-Radical
	
	222	passiv-preteritum-Neutral
	222a	passiv-preteritum-Sideform_a

	223	passiv-perfektum_partisipp-Neutral
	223a	passiv-perfektum_partisipp-Sideform_a

);


sub processes {
	
	# Sub that is called from the inflectormain file VIPS_vX.pl
	# Get the arguments
	my ($wordstem,$ortending,$trkstem,$trkending,$morftag,$full_paradigm_name) = @_;
	$t->insert("end","\n\n--------------------------------------\nProcesses called with args: ".(join "--",@_)."\n") if $winlog;
	
	print LOG "\n###\nNow processing the word form $wordstem \+ $ortending \/ $trkstem + $trkending\n" if $printlog;
	
	# Perform actions where you need to know the exact splitting point stem-ending in the transcription
	($trkstem,$trkending) = &split_point_processes($trkstem,$trkending);

	# Perform actions on the stems
	my $new_wordstem = &ort_stem_processes($wordstem,$full_paradigm_name);
	my ($new_trkstem,$nr_of_sylls) = &trk_stem_processes($trkstem,$full_paradigm_name);

	my $new_ort = &ort_processes(($new_wordstem.$ortending),$full_paradigm_name);
	my $new_trk = &trk_processes($new_trkstem.$trkending,$full_paradigm_name,$nr_of_sylls);

	print ARILD "$new_ort\t$new_trk\t$globsubrule\t$MORF_DESCR{$morftag}\t$globlist[1]\t$full_paradigm_name\t$morftag\n" if $printarild;

#Lasses versj.	print ARILD "$globlist[20]\t$globlist[2]\t$wordstem--$ortending\t$trkstem--$trkending\t$new_ort\t$new_trk\t$globlist[9]\t$full_paradigm_name\t$globsubrule\t$morftag\t$MORF_DESCR{$morftag}\n" if $printarild;
#	$arild .= "$new_ort\t$new_trk\t$MORF_DESCR{$morftag}\t";
	return "$new_ort\t$new_trk\t$MORF_DESCR{$morftag}\n";
} # end sub


sub split_point_processes {
	my ($trkstem,$trkending) = @_;
	
	#if a stem final 'n' meets an ending initial 'g' or 'k', the 'n' becomes 'nK'.
	if ($trkstem =~ /n[\.'2\"]*?$/ and $trkending =~ /^[\.'2\"]*?[gk]/) {$trkstem =~ s/n([\.'2\"]*?)$/nK$1/}
	
	#if a stem final 'nK' meets an ending initial 'j', the 'nK' should very VERY likely become 'n'.
	if ($trkstem =~ /nK[\.'2\"]*?$/ and $trkending =~ /^[\.'2\"]*?j/) {$trkstem =~ s/nK([\.'2\"]*?)$/n$1/}
	
	return ($trkstem,$trkending);
}


sub ort_stem_processes {
	my $ort_stem = shift;
	my $p = shift;
	print LOG "No processes yet defined for orthographic stem in sub ort_stem_processes\($ort_stem\,$p\).\n" if $printlog;
	
	return $ort_stem;

}


sub ort_processes {
	my $ort = shift;
	my $p = shift;

	$ort = &consonant_simplification($p,$ort);	# Consonant simplification for words with  in the orthographic rule
	print LOG "\$ort=$ort  after consonant simplification for words with  in the orthographic rule\n" if $printlog;
	$t->insert("end","consonant_simplification:           ".$ort."\n") if $winlog;

	$ort = &consonant_doubling($p,$ort);	# Consonant doubing for words with & in the orthographic rule
	print LOG "\$ort=$ort  after consonant doubling for words with & in the orthographic rule\n" if $printlog;
	$t->insert("end","consonant_doubling:           ".$ort."\n") if $winlog;

	$ort = &umlaut_ort($p,$ort);		# Umlaut for words with " in the orthographic rule
	print LOG "\$ort=$ort  after umlaut for words with \" in the orthographic rule\n" if $printlog;
	$t->insert("end","umlaut_ort:           ".$ort."\n") if $winlog;
	
	return $ort;
}


sub trk_stem_processes {  #($trkstem,$full_paradigm_name)
	my $trk_stem = shift;
	my $p = shift;
	my $nr_of_sylls;

	print LOG "No processes yet defined for trk stem in sub trk_stem_processes\($trk_stem\,$p\).\n" if $printlog;

	($trk_stem,$nr_of_sylls) = &RemSyll($trk_stem);
	$t->insert("end","Remove Syll:               ".$trk_stem."\t$nr_of_sylls\n") if $winlog;
	return ($trk_stem,$nr_of_sylls);
}


sub trk_processes {
	$t->insert("end","Trkprocesses called with args: ".(join "--",@_)."\n\n") if $winlog;
	my $trk = shift;
	my $p = shift;
	my $nr_of_sylls = shift;
	my $move_stress = 0;
	
	print LOG "\$trk=$trk  after pasting the trksuff\n" if $printlog;

	$trk = &just_doit2($trk,$nr_of_sylls);
	print LOG "\$trk=$trk  after sub just_doit2\n" if $printlog;
	$t->insert("end","just_doit2:                ".$trk."\n") if $winlog;

	$trk = &umlaut_trk($trk,$nr_of_sylls);	# Umlaut change for words with # in the phonological rule
	print LOG "\$trk=$trk  after umlaut change for words with # in the phonological rule\n" if $printlog;
	$t->insert("end","umlaut_trk:           ".$trk."\n") if $winlog;

	$trk = &vowel_shortening($trk,$nr_of_sylls);	#make the long (stressed) vowel short if  in the phonological rule, operates on the last syllable in $trk
	print LOG "\$trk=$trk  after vowel shortening in words with  in the phonological rule\n" if $printlog;
	$t->insert("end",$trk."\n") if $winlog;

	$trk = &acc_shift_3_2($p,$trk);	#change the LAST toneme type to type 2 if it is of type 1 or type 2 for words with no secondary stress. Operates if phonological rule has index 
	print LOG "\$trk=$trk  after tonemic shift from 1 to 2 in words with  in the phonological rule, applies to the last toneme if it is of type 1 or type 2 for words with no secondary stress\n" if $printlog;
	$t->insert("end","acc_shift_3_2:             ".$trk."\n") if $winlog;

	# sub just_doit doesn't work with indexes, but we must remember to move stress after it has been applied 
	if ($trk =~ //) {$move_stress = 1}
	$t->insert("end","move_stress:               ".$move_stress."\n") if $winlog;

	$trk = &acc_shift_any_3($p,$trk);	# Accent shift to toneme 1 for words with only toneme 2 and  in the phonological rule
	print LOG "\$trk=$trk  after tonemic shift from 2 to 1 in words with  in the phonological rule\n" if $printlog;
	$t->insert("end","acc_shift_any_3:           ".$trk."\n") if $winlog;

	# Now it is safe to remove indexes...
	$trk =~ s/[\#]//g;
	#...and apply sub...
	print LOG "\$trk=$trk  before sub just_doit and after global index removal\n" if $printlog;

	$trk = &move_stress($trk) if $move_stress;	#move stress
	print LOG "\$trk=$trk  after stress move in words with  in the phonological rule\n" if $printlog;
	$t->insert("end","move_stress:               ".$trk."\n") if $winlog;

	$trk = &syllab_cons($trk,$nr_of_sylls);	# Change to syllabic consonants for all words
	print LOG "\$trk=$trk  after change to syllabic consonants\n" if $printlog;
	$t->insert("end","syllab_cons:           ".$trk."\n") if $winlog;
	
	$trk = &devoicing($trk,$nr_of_sylls);	# V->f  g->k  b->p
	print LOG "\$trk=$trk  after devoicing\n" if $printlog;
	$t->insert("end","devoicing:                 ".$trk."\n") if $winlog;

	$trk = &new_retr($trk,$nr_of_sylls);
	print LOG "\$trk=$trk  after retroflexation\n" if $printlog;
	$t->insert("end","new_retr:                  ".$trk."\n") if $winlog;

	# double s+ -> s+s:
	$trk =~ s/s\+s\+/\s\+s/;
	print LOG "\$trk=$trk  after double s+ -> s\n" if $printlog;
	$t->insert("end","double s+ -> s+s:          ".$trk."\n") if $winlog;
	
	return $trk;
} # end sub


sub RemSyll {
	my $trkstem = shift;
	print LOG "For the trkstem $trkstem we remove syllable marker " if $printlog;
	my $m = "";
	#my $presylls = 0;
	# om det finns en stavelsegrns, s hmta den sista stavelsen fram till skarven
	if ($trkstem =~ /\.([^\.]*)$/) {
		$m = $1;
		unless ($m =~ /(E\&U0|E\+\&Y|n\+\%\)|l\+\%\)|n\%\)|l\%\)|E\&I|A\&I|O\&I|e\+:|u0:|i:|y:|e:|\@:|A:|u:|o:|U0|E\+|E|I|O|U|Y|A|\')/) {$trkstem =~ s/\.([^\.]*)$/$m/}
	}
	my $nr_of_sylls = split /\./,$trkstem;   # remember in which syll we shall do retroflexation and start resyllabification
	print LOG "and obtain $trkstem\n" if $printlog;
	return ($trkstem,$nr_of_sylls);
} # end sub

sub x_ify_lh {

	# Fr ver inargumentlistans frsta
	# (och i detta fallet enda) element
	# till den lokala variabeln $t.

	my $ttt = shift;


	# Nedan grs en rcka substitutioner
	# som gradvis omformar $ttt (en lh+representation)
	# till en sekvens av nyckelvrden, vart
	# och ett inledda med tecknet 'x'. Valde
	# detta tecken fr att det inte ingr i telias
	# uppsttning av fonemrepresentationer.
	# Fr att det ska fungera mste man gra substitu-
	# tioner p de LNGSTA mnstren frst:

	$ttt =~ s/E\&U0/x151/g;	#OK	diftong au
	$ttt =~ s/E\+\&Y/x153/g;	#OK	diftong y
	$ttt =~ s/E\&I/x152/g;	#OK	diftong ei
	$ttt =~ s/n\+%\)/x930/g;	#	stavelsesbrende konsonant n+
	$ttt =~ s/l\+%\)/x940/g;	#	stavelsesbrende konsonant l+
	$ttt =~ s/A\&I/x154/g;	#OK	diftong ai
	$ttt =~ s/O\&I/x155/g;	#OK	diftong oi
	$ttt =~ s/t\&S/x190/g;	#	ustemt affrikat tsjekkia
	$ttt =~ s/n%\)/x910/g;	#	stavelsesbrende konsonant n
	$ttt =~ s/l%\)/x920/g;	#	stavelsesbrende konsonant l
	$ttt =~ s/u0:/x050/g;	#OK	lang vokal u
	$ttt =~ s/e\+:/x090/g;	#OK	lang vokal 
	$ttt =~ s/A:/x010/g;	#OK	lang vokal a
	$ttt =~ s/e:/x020/g;	#OK	lang vokal e
	$ttt =~ s/i:/x030/g;	#OK	lang vokal i
	$ttt =~ s/u:/x040/g;	#OK	lang vokal o
	$ttt =~ s/y:/x060/g;	#OK	lang vokal y
	$ttt =~ s/o:/x070/g;	#OK	lang vokal 
	$ttt =~ s/\@:/x081/g;	#OK	lang vokal 
	$ttt =~ s/U0/x221/g;	#OK	kort vokal u
	$ttt =~ s/E\+/x091/g;	#OK	kort vokal 
	$ttt =~ s/d\+/x100/g;	#OK	retrofleks d
	$ttt =~ s/t\+/x110/g;	#OK	retrofleks t
	$ttt =~ s/n\+/x130/g;	#OK	retrofleks nasal
	$ttt =~ s/l\+/x140/g;	#OK	retrofleks lateral
	$ttt =~ s/nK/x400/g;	#OK	velar nasal
	$ttt =~ s/r6/x421/g;	#OK	alveolar flap
	$ttt =~ s/2\'/x510/g;	#OK	tonem 2
	$ttt =~ s/\'2/x520/g;	#OK	bitrykk
	$ttt =~ s/A/x181/g;	#OK	kort vokal a
	$ttt =~ s/I/x200/g;	#OK	kort vokal i
	$ttt =~ s/U/x210/g;	#OK	kort vokal u
	$ttt =~ s/Y/x230/g;	#OK	kort vokal y
	$ttt =~ s/O/x240/g;	#OK	kort vokal 
	$ttt =~ s/E/x250/g;	#OK	kort vokal e
	$ttt =~ s/b/x270/g;	#OK	b
	$ttt =~ s/d/x280/g;	#OK	d
	$ttt =~ s/g/x290/g;	#OK	g
	$ttt =~ s/p/x300/g;	#OK	p
	$ttt =~ s/t/x310/g;	#OK	t
	$ttt =~ s/k/x320/g;	#OK	k
	$ttt =~ s/f/x330/g;	#OK	f
	$ttt =~ s/s/x340/g;	#OK	s
	$ttt =~ s/S/x341/g;	#OK	sj
	$ttt =~ s/V/x360/g;	#OK	v
	$ttt =~ s/C/x370/g;	#OK	kj
	$ttt =~ s/m/x380/g;	#OK	m
	$ttt =~ s/n/x390/g;	#OK	n
	$ttt =~ s/l/x410/g;	#OK	l
	$ttt =~ s/h/x430/g;	#OK	h
	$ttt =~ s/j/x440/g;	#OK	j
	$ttt =~ s/\'/x500/g;	#OK	hovedtrykk
	$ttt =~ s/\./x530/g;	#OK	stavelsesgrense
	$ttt =~ s/\_/x550/g;	#OK	underscore
	$ttt =~ s/\"/x570/g;	#OK	fraseaksent

	$t->insert("end","xify returns:   $ttt\n") if $winlog;
	return $ttt;

} # end sub


sub syllabify {

	# Arbetar i stort sett enligt Cattis frslagsalgoritm
	# Instrng r en enstaka stavelse som eventuellt kan
	# stavelseindelas ytterligare enligt MOP.
	# Algoritm:
	# - Ls strngen t.o.m frsta vokalen som ptrffas och skala av denna delstrng.
	# - Denna delstrng undersks fr konstituenter enligt fljande:
	#      - optionell offset (vilken strng som helst) fljt av
	#      - optionell onset (enl. dokumentation av Cattis, $onset_pattern) fljt av
	#      - optionell stressmarkering (enligt teliadokumentation, $stress_pattern) fljt av
	#      - obligatorisk nucleus ($voc_pattern)
	# Varje avskalad och uppdelad delstrng appendas till en returneringsstrng enligt fljande:
	#      - ev. offset + stavelsegrnsmarkering + ev. stressmarkering + ev. onset + nucleus.
	# Efterbearbetning sedan loopen r genomgngen:
	#      - den inledande stavelsegrnsmarkeringen tas bort.
	#      - resten av instrngen (dvs det som kommer efter den sista vokalen, den 'sista eventuella offseten'
	#        appendas till returstrngen.


	my $ilstring = shift;
	my $voc_pattern = "(x010|x020|x030|x040|x050|x060|x070|x081|x090|x091|x151|x152|x153|x154|x155|x181|x200|x210|x221|x230|x240|x250|x910|x920|x930|x940)";
#	my $stress_pattern = "(x500|x510|x520|)";

	my $stress_pattern = "(x500|x510|x520|x570|)";
	my $syll_pattern = "x530";

	my $onset_pattern = join "|",@il_onsets;
	$onset_pattern =~ s/^(.*)$/\($1|\)/;

	my $ret = "";

	while ($ilstring =~ s/^((.*?)($stress_pattern)($onset_pattern)($voc_pattern))//) {
		$ret .= "$2$syll_pattern$3$5$7";
	}

	$ret .= $ilstring;
	$ret =~ s/^$syll_pattern//;
	
	$ret = fix_corrupt_syll($ret);
	return $ret;

} # end sub


# Fix that takes care of unusual initial clusters such as ts, ps and so on that are not legal onsets but exists
# appends syllables with no vowel with the syllable that follows 
sub fix_corrupt_syll {
	my $ret = shift;
	my $newret = "";
	my @newsylls = ();
	my $deletetag = "TABORT";
	my @sylls = split /x530/,$ret;

#svensk	my $voc_pattern = "(x010|x020|x030|x040|x050|x060|x070|x080|x090|x150|x160|x170|x180|x190|x200|x210|x220|x230|x240|x250|x260)";
	my $voc_pattern = "(x010|x020|x030|x040|x050|x060|x070|x081|x090|x091|x151|x152|x153|x154|x155|x181|x200|x210|x221|x230|x240|x250|x910|x920|x930|x940)";
	foreach $s (@sylls) {
		unless ($s =~ /$voc_pattern/) {
			$s = $s.$deletetag;
		} # end unless
		push @newsylls,$s;
	}
	$newret = join "x530",@newsylls;
#	print LOG "NEWRET BEFORE: $newret\n" if $printlog;	
	$newret =~ s/TABORTx530//g;
#	print LOG "NEWRET AFTER: $newret\n" if $printlog;
	return $newret;
} # end sub


sub new_retr {
	my ($trk,$nr_of_sylls) = @_;
	my ($stemkons,$stemstart,$hops,$untouched,$touched);
	my $shortv = q(U0|E\+|E|I|O|U|Y|A);
	my $stress = q(2\'|\'2|\');
	my $stress_or_syll = q(2\'|\'2|\'|\.);

	my $printlog_retr = 0;

#svensk	my $retrCs = q(d|t|s|n);

	my $retrCs = q/n%\)|l%\)|d|t|s|n|l/;
	my @sylls = split /\./,$trk;
	if ($nr_of_sylls > 1) {
		$untouched = join ".",@sylls[0..($nr_of_sylls-2)];
		$touched = join ".",@sylls[($nr_of_sylls-1)..$#sylls]
	}
	else {
		$untouched = "";
		$touched = $trk;
	}
	$t->insert("end","(new_retr is operating on:  ".$touched.")\n") if $winlog;
	$hops = $touched;
#	$hops =~ s/^(($stress)[^\.]*?($shortv)r6($stress_or_syll)*)($retrCs)([^\+].*|)$/$1X$5X$6/g;
#	$t->insert("end", "-- $1 -- X -- $4 -- X -- $5 --\n------------\nny hops: $hops\n") if $winlog;

#svensk original	$hops =~ s/([^\']+?)r(($stress_or_syll)*)($retrCs)([^\+]|$)/$1$2$4\+$5/g;

print LOG "BEFORE r6 REPLACEMENT: $hops\n" if $printlog_retr;


	#fikser bde vanlige og stavelsesbrende konsonanter, men ikke s
	$hops =~ s/([^\']+?)r6(($stress_or_syll)*)(d|t|n|l)([^\+]|$)/$1$2$4\+$5/g;

print LOG "AFTER 1ST r6 REPLACEMENT: $hops\n" if $printlog_retr;

	#fikser s
	$hops =~ s/([^\']+?)r6(($stress_or_syll)*)s([^\+]|$)/$1$2S$4/g;

print LOG "AFTER 2ND r6 REPLACEMENT: $hops\n" if $printlog_retr;


print LOG "BEFORE FOREACH LOOP: $hops\n" if $printlog_retr;

	foreach (0..4) {
#svensk original	$hops =~ s/(($retrCs)\+($stress_or_syll)*($retrCs))([^\+]|$)/$1\+$5/g;

		#fikser stav.b. konsonant n etterfulgt av vrige kons, ikke s, fordi "abortens" ikke skal ha retrofleksering av siste s
		$hops =~ s/((n\+%\)($stress_or_syll)*(d|t|n|l)))([^\+]|$)/$1\+$5/g;


print LOG "AFTER 1ST REPLACEMENT: $hops\n" if $printlog_retr;

		#fikser stav.b. konsonant l etterfulgt av vrige kons, ikke s
		$hops =~ s/((l\+%\)($stress_or_syll)*(d|t|n|l))([^\+]|$))/$1\+$5/g;
print LOG "AFTER 2ND REPLACEMENT: $hops\n" if $printlog_retr;

		#fikser vrige konsonanter etterfulgt av stav.b. konsonanter
		$hops =~ s/((d|t|n|l)\+($stress_or_syll)*)(n|l)(%\))/$1$4\+$5/g;
print LOG "AFTER 3RD REPLACEMENT: $hops\n" if $printlog_retr;

		#fikser vrige konsonanter, ikke s, etterfulgt av vrige kons, ikke s,
		$hops =~ s/((d|t|n|l)\+($stress_or_syll)*(d|t|n|l))([^\+]|$)/$1\+$5/g;
print LOG "AFTER 4TH REPLACEMENT: $hops\n" if $printlog_retr;

		#fikser vrige konsonanter, ikke s, etterfulgt av s
		$hops =~ s/((d|t|n|l)\+($stress_or_syll)*)s/$1S/g;
print LOG "AFTER 5TH REPLACEMENT: $hops\n" if $printlog_retr;

#removed 28/2-2001, due to error with "apanasjen" etc.
		#fikser S etterfulgt av stav.b. konsonanter
#		$hops =~ s/(S($stress_or_syll)*)(n|l)(%\))/$1$3\+$4/g;
#print LOG "AFTER 6TH REPLACEMENT: $hops\n" if $printlog_retr;

#removed 28/2-2001, due to error with "apanasjen" etc.
		#fikser S etterfulgt av vrige konsonanter
#		$hops =~ s/(S($stress_or_syll)*(d|t|n|l))([^\+]|$)/$1\+$4/g;
#print LOG "AFTER 7TH REPLACEMENT: $hops\n" if $printlog_retr;

		#fikser S etterfulgt av s
		$hops =~ s/(S($stress_or_syll)*)s([^\+]|$)/$1$5/g;
print LOG "AFTER 8TH REPLACEMENT: $hops\n" if $printlog_retr;

	} # end foreach
#	$hops =~ s/X(.)X/$1/g;
	return $untouched.".".$hops if $untouched;
	return $hops;	
}


################### TRK PROCESSING SUBS ########################################

# Vowel shortening for word forms indexed  in the phonological rule applied.
sub vowel_shortening {
	my ($trk,$nr_of_sylls) = @_;
	
	my ($stemkons,$stemstart,$untouched,$touched);
	my $i;

	# get the part to operate on
	my @sylls = split /\./,$trk;
	if ($nr_of_sylls > 1) {
		$untouched = join ".",@sylls[0..($nr_of_sylls-2)];
		$touched = join ".",@sylls[($nr_of_sylls-1)..$#sylls]
	}
	else {
		$untouched = "";
		$touched = $trk;
	}

	my $was_touched = $touched;

	if ($touched =~ //) {
		my @trksylls = split /\./,$touched;
		foreach $i ((-1,-2,-3)) {
			if (scalar @trksylls >= -$i) {
			$trksylls[$i] =~ s/e\+:/E\+/;	#rd - rdt
			$trksylls[$i] =~ s/u0:/U0/;	#ru
			$trksylls[$i] =~ s/A:/A/;	#hard - hardt
			$trksylls[$i] =~ s/e:/E/;	#bred - bredt
			$trksylls[$i] =~ s/i:/I/;	#hvit - hvitt
			$trksylls[$i] =~ s/u:/U/;
			$trksylls[$i] =~ s/y:/Y/;
			$trksylls[$i] =~ s/o:/O/;	#bl - bltt
			$trksylls[$i] =~ s/\@:/E/;
			}
		}
		$touched = join "\.",@trksylls;
	}
	$t->insert("end","vowel_shortening($was_touched): ") if $winlog;

	return $untouched.".".$touched if $untouched;
	return $touched;	
	
} # end sub


# Tonemic shift from 1 to 2 of the LAST toneme to type 2 for words with no secondary stress
sub acc_shift_3_2 {
	my ($p,$trk) = @_;

	my @sylls = split /\./, $trk;
	my $ant = scalar (@sylls);

#print LOG "\n\$ant=$ant ved inngang i acc_shift_3_2\n\n" if $printlog;

	if ($trk =~ //) {
		#TONEMENDRING I SUBSTANTIV-SPESIFIKKE KONTEKSTER (enstavingsord dag -> dager(s), dagene(s))
		if (($trk =~ /Er6[\#]*$/) and not ($trk =~ /\..*\./))  {
			$trk =~ s/\'([^2][^\']+)$/2\'$1/;
			$trk =~ s/22/2/g;
		}

		elsif (($trk =~ /nE[\#]*$/) and ($trk =~ /\..*\./) and not ($trk =~ /\..*\..*\./))  {
			$trk =~ s/\'([^2][^\']+)$/2\'$1/;
			$trk =~ s/22/2/g;
		}

		elsif (($trk =~ /n\%\)\.E[\#]*$/) and ($trk =~ /\..*\./) and not ($trk =~ /\..*\..*\./))  {
			$trk =~ s/\'([^2][^\']+)$/2\'$1/;
			$trk =~ s/22/2/g;
		}

		elsif (($trk =~ /ES[\#]*$/) and not ($trk =~ /\..*\./))  {
			$trk =~ s/\'([^2][^\']+)$/2\'$1/;
			$trk =~ s/22/2/g;
		}

		elsif (($trk =~ /nEs[\#]*$/) and ($trk =~ /\..*\./) and not ($trk =~ /\..*\..*\./))  {
			$trk =~ s/\'([^2][^\']+)$/2\'$1/;
			$trk =~ s/22/2/g;
		}
		
		elsif (($trk =~ /n\%\)\.Es[\#]*$/) and ($trk =~ /\..*\./) and not ($trk =~ /\..*\..*\./))  {
			$trk =~ s/\'([^2][^\']+)$/2\'$1/;
			$trk =~ s/22/2/g;
		}
		
		#TONEMENDRING I ADJEKTIV-SPESIFIKKE KONTEKSTER (enstavingsord redd -> redde(s), reddere(s), reddeste(s))
		elsif (($trk =~ /E[\#]*$/) and ($ant < 3)) {
			$trk =~ s/\'([^2][^\']+)$/2\'$1/;
			$trk =~ s/22/2/g;
		}

		elsif (($trk =~ /E\.r6E[\#]*$/) and ($ant == 3)) {
			$trk =~ s/\'([^2][^\']+)$/2\'$1/;
			$trk =~ s/22/2/g;
		}

		elsif (($trk =~ /E\.stE[\#]*$/) and ($ant == 3)) {
			$trk =~ s/\'([^2][^\']+)$/2\'$1/;
			$trk =~ s/22/2/g;
		}
		
		elsif (($trk =~ /Es[\#]*$/) and ($ant == 2)) {
			$trk =~ s/\'([^2][^\']+)$/2\'$1/;
			$trk =~ s/22/2/g;
		}

		elsif (($trk =~ /E\.r6Es[\#]*$/) and ($ant == 3)) {
			$trk =~ s/\'([^2][^\']+)$/2\'$1/;
			$trk =~ s/22/2/g;
		}

		elsif (($trk =~ /E\.stEs[\#]*$/) and ($ant == 3)) {
			$trk =~ s/\'([^2][^\']+)$/2\'$1/;
			$trk =~ s/22/2/g;
		}

		elsif (($trk =~ /stE[\#]*$/) and ($ant == 2)) {		#strste (18/11-00)
			$trk =~ s/\'([^2][^\']+)$/2\'$1/;
			$trk =~ s/22/2/g;
		}

		elsif (($trk =~ /stEs[\#]*$/) and ($ant == 2)) {		#strstes
			$trk =~ s/\'([^2][^\']+)$/2\'$1/;
			$trk =~ s/22/2/g;
		}

		#TONEMENDRING I VERB-SPESIFIKKE KONTEKSTER (enstavingsord redd -> redde(s), reddere(s), reddeste(s))
		elsif (($trk =~ /dE[\#]*$/) and ($ant == 2)) {		#grodde (28/11-00)
			$trk =~ s/\'([^2][^\']+)$/2\'$1/;
			$trk =~ s/22/2/g;
		}

		elsif (($trk =~ /dEs[\#]*$/) and ($ant == 2)) {		#groddes (28/11-00)
			$trk =~ s/\'([^2][^\']+)$/2\'$1/;
			$trk =~ s/22/2/g;
		}

		elsif (($trk =~ /InK[\#]*$/) and ($ant == 2)) {		#groing (29/11-00)
			$trk =~ s/\'([^2][^\']+)$/2\'$1/;
			$trk =~ s/22/2/g;
		}

		elsif (($trk =~ /Et[\#]*$/) and ($ant == 2)) {		#flyet (7/1-01)
			$trk =~ s/\'([^2][^\']+)$/2\'$1/;
			$trk =~ s/22/2/g;
		}

		elsif (($trk =~ /Ets[\#]*$/) and ($ant == 2)) {		#flyets (7/1-01)
			$trk =~ s/\'([^2][^\']+)$/2\'$1/;
			$trk =~ s/22/2/g;
		}

		elsif (($trk =~ /E\.tE[\#]*$/) and ($ant == 3)) {		#flyete (27/2-01)
			$trk =~ s/\'([^2][^\']+)$/2\'$1/;
			$trk =~ s/22/2/g;
		}

		elsif (($trk =~ /E\.tEs[\#]*$/) and ($ant == 3)) {		#flyetes (27/2-01)
			$trk =~ s/\'([^2][^\']+)$/2\'$1/;
			$trk =~ s/22/2/g;
		}


	}
	return $trk;
}


# Tonemic shift from 2 to 1 if there is an index  in the phonological rule
sub acc_shift_any_3 {
	my ($p,$trk) = @_;
	if ($trk =~ /^2\'[^\']+/) {$trk =~ s/^2\'/\'/}
	return $trk;
}


# Move stress for flagged words
sub move_stress {
	my ($trk) = @_;
	$trk =~ /^([^2\']*)(2\'|\'2|\')([^\.]+)(\.)([^\']+)$/;
	my $pre = $1;
	my $laststressmark = $2;
	my $laststressedsyll = $3;
	my $syllmark = $4;
	my $suff = $5;
	# make long vowel short in syllable that looses stress
	$laststressedsyll =~ s/e\+:/E\+/;
	$laststressedsyll =~ s/u0:/U0/;
	$laststressedsyll =~ s/A:/A/;
	$laststressedsyll =~ s/e:/E/;
	$laststressedsyll =~ s/i:/I/;
	$laststressedsyll =~ s/u:/U/;
	$laststressedsyll =~ s/y:/Y/;
	$laststressedsyll =~ s/o:/O/;
	$laststressedsyll =~ s/\@:/E/;
	# and move the stressmark

	print LOG "\$pre=$pre\n" if $printlog;
	print LOG "\$laststressmark=$laststressmark\n" if $printlog;
	print LOG "\$laststressedsyll=$laststressedsyll\n" if $printlog;
	print LOG "\$syllmark=$syllmark\n" if $printlog;
	print LOG "\$suff=$suff\n" if $printlog;

	$trk = $pre.$laststressedsyll.$syllmark.$laststressmark.$suff;
	return $trk;
}


#Devoicing in all words
sub devoicing {	
	my ($trk,$nr_of_sylls) = @_;

	my ($stemkons,$stemstart,$untouched,$touched);
	my $i;
	
	# get the part to operate on
	my @sylls = split /\./,$trk;
	if ($nr_of_sylls > 1) {
		$untouched = join ".",@sylls[0..($nr_of_sylls-2)];
		$touched = join ".",@sylls[($nr_of_sylls-1)..$#sylls]
	}
	else {
		$untouched = "";
		$touched = $trk;
	}

	# devoicing of bdg to ptk.  Look for: ---syllmarker or string start    ---shortest sequense of nostressmarks   ---short vowel   ---One bdg   ---ptks   ---anything(inkluding retroflmarker)
	# different from Swedish, no devociing before genitive s in Norwegian
	$touched =~ s/((U0|E\+|E|I|O|U|Y|A)[\.'2"]*?)d([\.'2"]*?[ptk]\+)/$1t\+$3/;
	$touched =~ s/((U0|E\+|E|I|O|U|Y|A)[\.'2"]*?)b([\.'2"]*?[ptk])/$1p$3/;
	$touched =~ s/((U0|E\+|E|I|O|U|Y|A)[\.'2"]*?)d([\.'2"]*?[ptk])/$1t$3/;
	$touched =~ s/((U0|E\+|E|I|O|U|Y|A)[\.'2"]*?)g([\.'2"]*?[ptk])/$1k$3/;

	$touched =~ s/tt/t/g;
	$touched =~ s/pp/p/g;
	$touched =~ s/kk/k/g;
	$touched =~ s/t\+t\+/t\+/g;

	return $untouched.".".$touched if $untouched;
	return $touched;	
}


# Phonological umlaut change for words with # in the orthographic rule
sub umlaut_trk {
	my ($trk,$nr_of_sylls) = @_;
	if ($trk =~ /#/) {
		$trk =~ s/#//;
		my @trksylls = split /\./,$trk;

		if ($trksylls[-1] =~ /\'/) { # omlyd i enstavingsord som t - tr
			$trksylls[-1] =~ s/u:/e\+:/;		#bok - bker
			$trksylls[-1] =~ s/A:/e:/;		#stad - steder
			$trksylls[-1] =~ s/o:/\@:/;		#tg - tger, t - tr
			$trksylls[-1] =~ s/u0:/y:/;		#ku - kyr
			$trksylls[-1] =~ s/A/E/;		#and - ender, mann - menn
			$trksylls[-1] =~ s/U/E+/;		#bonde bnder
		}
	
		elsif ($trksylls[-2] =~ /\'/) { # omlyd i nest siste stavelse i ord som bok - bker
			$trksylls[-2] =~ s/u:/e\+:/;		#bok - bker
			$trksylls[-2] =~ s/A:/e:/;		#stad - steder
			$trksylls[-2] =~ s/o:/\@:/;		#tg - tger, t - tr
			$trksylls[-2] =~ s/u0:/y:/;		#ku - kyr
			$trksylls[-2] =~ s/A/E/;		#and - ender, mann - menn
			$trksylls[-2] =~ s/U/E+/;		#bonde bnder
		}

		else { #omlyd i tredje siste stavelse i vrige tilfeller, alts bonde - bndene
			$trksylls[-3] =~ s/u:/e\+:/;		#bok - bker
			$trksylls[-3] =~ s/A:/e:/;		#stad - steder
			$trksylls[-3] =~ s/o:/\@:/;		#tg - tger, t - tr
			$trksylls[-3] =~ s/u0:/y:/;		#ku - kyr
			$trksylls[-3] =~ s/A/E/;		#and - ender, mann - menn
			$trksylls[-3] =~ s/U/E+/;		#bonde bnder
		}

		$trk = join "\.", (@trksylls);
	}
	return $trk;
} #end sub


#Conversion to syllabic consonant in nominal endings
sub syllab_cons {
	my ($trk,$nr_of_sylls) = @_;
	

print LOG "\n\$trk=$trk -- \$nr_of_sylls=$nr_of_sylls ved inngang i syllab_cons\n" if $printlog;

	my @sylls = split /\./, $trk;
	my $ant = scalar (@sylls);

print LOG "\n\$ant=$ant ved inngang i syllab_cons\n\n" if $printlog;

#27/2-01 to avoid overgeneration on disyllabic words:
if ($ant > 2) {

	#endrer ord som himmel - himmelen
	if ($trk =~ /s$/) {
		$trk =~ s/E\.lEns$/Elns/;
	}

	else {
		$trk =~ s/E\.lEn$/Eln/;
	}

	#endrer ord som adel - adelen, som har stavelsesbrende konsonant
	if ($trk =~ /s$/) {
		$trk =~ s/l%\)\.Ens$/Elns/;

	}


	else {
		$trk =~ s/l%\)\.En$/Eln/;

	}


}
#27/2-01

	#endrer ord som naturen, redaktren, doktorenes, men ikke enstavingsord med kort vokal, som narr, herr
	if ($trk =~ /s$/) {					#genitivsformer
		if ($ant > 2) {					#fler enn to stavelser
			$trk =~ s/\.r6Ens$/\.n\+%\)s/;

		}



		elsif (($ant == 2) && ($trk =~ /:/)) {		#nyaktig to stv, kun hvis lang vokal (barens)
			$trk =~ s/\.r6Ens$/\.n\+%\)s/;

		}



		if ($ant > 3) {
			$trk =~ s/\.r6E\.nEs$/\.n\+%\)\.Es/;

		}


		elsif (($ant == 3) && ($trk =~ /:/)) {
			$trk =~ s/\.r6E\.nEs$/\.n\+%\)\.Es/;

		}



	}
								#nominativsformer
	else {
		if ($ant > 2) {					#fler enn to stavelser
			$trk =~ s/\.r6En$/\.n\+%\)/;

		}


		elsif (($ant == 2) && ($trk =~ /:/)) {		#nyaktig to stv, kun hvis lang vokal (barens)
			$trk =~ s/\.r6En$/\.n\+%\)/;

		}



		if ($ant > 3) {
			$trk =~ s/\.r6E\.nE$/\.n\+%\)\.E/;

		}


		elsif (($ant == 3) && ($trk =~ /:/)) {
			$trk =~ s/\.r6E\.nE$/\.n\+%\)\.E/;

		}


	}

	#gjr om til stavelsesbrende konsonant:
	if ($trk =~ /s$/) {
		if ($ant > 1) {		#so as to avoid reduction in "lens" (28/2-2001)
			$trk =~ s/(d|l|n|s|t|S|n\+|t\+|l\+|d\+)Ens$/$1n%\)s/;
		}
		
		if ($ant > 2) {		#so as to avoid reduction in "tennes" (28/2-2001)
			$trk =~ s/(d|l|n|s|t|S|n\+|t\+|l\+|d\+)E\.nEs$/$1n%\)\.Es/;
		}
		

	}
	else {
		if ($ant > 1) {		#so as to avoid reduction in "tenn" (28/2-2001)
			$trk =~ s/(d|l|n|s|t|S|n\+|t\+|l\+|d\+)En$/$1n%\)/;
		}
		

		if ($ant > 2) {		#so as to avoid reduction in "tenne" (28/2-2001)
			$trk =~ s/(d|l|n|s|t|S|n\+|t\+|l\+|d\+)E\.nE$/$1n%\)\.E/;
		}

	}

	return $trk;
}



################### ORTHOGRAPHIC PROCESSING SUBROUTINES ########################################

# Consonant simplification for words with  in the orthographic rule
sub consonant_simplification {
	my ($p, $ort) = @_;
	my %cons_simpl = qw (bb b dd d ff f gg g kk k ll l mm m nn n pp p qq q rr r ss s tt t);
	if ($ort =~ //) {
		$ort =~ s/\//;
		$ort =~ s/mm$/m/;
		foreach $key (keys (%cons_simpl)) {

			$ort =~ s/$key(l|r|n|d)/$cons_simpl{$key}$1/;
			
			if ($ort =~ /($key)t(s)?$/) {
				$ort =~ s/($key)t(s)?$/$cons_simpl{$key}t$2/;
			}

			if ($ort =~ /($key)te(s)?$/) {
				$ort =~ s/($key)te(s)?$/$cons_simpl{$key}te$2/;
			}
			
		}
	} 
	return $ort;
} #end sub


# Consonant doubling for words with & in the orthographic rule
sub consonant_doubling {
	my ($p, $ort) = @_;
	my %cons_doubl = qw (b bb d dd f ff g gg k kk l ll m mm n nn p pp r rr s ss t tt);
	if ($ort =~ /\&/) {
		$ort =~s/\&//;

		#tar hnd om genitivsformer av substantiv og adjektiv
		if (($ort =~ /s$/) or ($ort =~ /s\"$/)) {
			foreach $key (keys (%cons_doubl)) {
				$ort =~ s/$key(ers(\")?|enes(\")?)$/$cons_doubl{$key}$1/;
				$ort =~ s/($key)es$/$cons_doubl{$key}es/;
			} #end foreach
		} #end if


		#tar hnd om nominativsformer av substantiv og adjektiv
		else {
			foreach $key (keys (%cons_doubl)) {
				$ort =~ s/$key(er(\")?|ene(\")?)$/$cons_doubl{$key}$1/; 	#subst
				$ort =~ s/($key)e$/$cons_doubl{$key}e/;		#adj
			}
		} #end else
	}
	return $ort;
} #end sub


# Orthographic umlaut change for words with " in the orthographic rule
sub umlaut_ort {
	my ($p, $ort) = @_;
	if ($ort =~ /\"/) {
		if ($ort =~ /s\"$/) {
			$ort =~ s/o(\w{1,3})ers\"$/$1ers/;
			$ort =~ s/a(\w{1,3})ers\"$/e$1ers/;
			$ort =~ s/(\w{1,3})ers\"$/$1ers/;
			$ort =~ s/o(\w{1,3})enes\"$/$1enes/;
			$ort =~ s/a(\w{1,3})enes\"$/e$1enes/;
			$ort =~ s/(\w{1,3})enes\"$/$1enes/;
		}
		 else {
		 	$ort =~ s/o(\w{1,3})er\"$/$1er/;
			$ort =~ s/a(\w{1,3})er\"$/e$1er/;
			$ort =~ s/(\w{1,3})er\"$/$1er/;
			$ort =~ s/o(\w{1,3})ene\"$/$1ene/;
			$ort =~ s/a(\w{1,3})ene\"$/e$1ene/;
			$ort =~ s/(\w{1,3})ene\"$/$1ene/;
		}
	}
	return $ort;
} #end sub


1;