#!perl
#uppdaterad 00.09.14 till version 8 som r den 'slutliga' versionen infr spotchecking av nomen
#uppdaterad 00.08.30/LW. Tar inte argument via en batfil utan allt mste specificeras direkt i denna filen
#uppdaterad 240500/ck gller fr substantiv,adjektiv,verb
#Call:  VIPS_shell.pl lang lexfile

$printarild = 1; # SET THIS TO 1 IF YOU WANT A FILE WITH INFLECTED FORMS, STEMS, LEMMAS, ENDINGS ETC.  OUTPUTS TO 'to_arild.OUT'.
$printstems = 0; # DO NOT SET THIS TO 1, doesent work any more/LW
$printlog = 0;
$printonlyOKposts = 0; # IF set to 1, accepts a lexikon with both ok and not ok posts according to last statusinfo in field 5, but disregards notokposts and posts marked as 'available'
$usedecomp = 1;  # if set to 1 uses decompstring instead of orthography

require 'VIPSnor_v4.pl';
require 'VIPS_v4.pl';
$rulefile = "VIPSnor_v5.rule";


#$lexfile = "temp_lexicon.lex";   ####################################  CHANGE LEXFILE TO INFLECT HERE!!!  #######################
#$lexfile = "Leksikonfil_substantiver_v8_0.OUT";	#SUBSTANTIVFILEN
#$lexfile = "Leksikonfil_adjektiver_v2_0.OUT";  	#ADJEKTIVFILEN
#$lexfile = "Leksikonfil_verb_v1_3.OUT";  		#VERBFILEN

#$lexfile = "lexicon_adj.lex";

$lexfile = "Leksikonfil_alle_v1_0.lex";  		#STORA FILEN

#$lexfile = "lexicon_small.lex";   ####################################  CHANGE LEXFILE TO INFLECT HERE!!!  #######################

$outfile = $rulefile."_decomp_".$lexfile."\.OUT";  ### output files name computed with rulefile and lexfile names appended with '.OUT'###

$postflag = 0;
@retposts = ();
open LOG,">VIPS_shell_4.LOG" if $printlog;
open STEMS, ">VIPS_shell_4.STEMS" if $printstems;
open ARILD, ">inflector_flat_file.OUT" if $printarild;

use locale;
use POSIX 'locale_h';
setlocale(LC_CTYPE,$locale{Swedish});

print LOG "Calling sub MkRuleHash($rulefile) returning a hash with paradigm name as key and subrule lines as values\n\n" if $printlog;
%raw_rules = &MkRuleHash($rulefile);
%rules = &PreprocessRule(%raw_rules);

print LOG "Opening an output file \'VIPS.OUT\'\n\n" if $printlog;
open OUT,">$outfile";

print LOG "Opening a lexiconfile \'$ARGV[1]\' to process\n\n" if $printlog;
open LEX,"$lexfile";

while (<LEX>) {
	chomp;
	undef @globlist;
	@globlist = split /\t/;
#	if (($globlist[5] !~ /status=OK[^<]+$/) and ($printonlyOKposts == 1)) {next}
	($ort,$trk,$code,$decomp,$id) = @globlist[1,3,0,4,2];
	($result,@retposts) = &vips($ort,$trk,$code,$decomp) unless $usedecomp;
	($result,@retposts) = &vips($decomp,$trk,$code,$decomp) if $usedecomp;	
	print OUT "$result\n\n===========================================================\n\nNEXT LEXENTRY:\n\n";
	

}

close OUT;
close LOG if $printlog;
close STEMS  if $printstems;
close LEX;
close ARILD;
