# !perl -w

open IN, "nor010226VILT.pron";
open OUT, ">LinkErrors.txt";

while (<IN>) {
	chomp;
	$linje = $_;
	@felt = split ";", $linje;
	$decomp = $felt[2];
	$decpos = $felt[4];

	@forms = split /\+/, $decomp;
	@tags = split /\+/, $decpos;

	$count = 0;
	foreach $tag (@tags) {
		if ($tag =~ /^link$/) {
			$item = $forms[$count];
			if ($item !~ /^(a|ar|e|en|er|es|n|r|s|-)$/) {
				print OUT "$linje\n";
			}
		}
		$count++;
	}
}

#foreach $key (sort keys (%linkhash)) {
#	print OUT "$key\t$linkhash{$key}\n";
#}
