# !perl -w

#Programmet analyserer alle dekomponerte ikke-garbage ord, 
#og klassifiserer forledd ut fra hvordan de danner sammensetninger.
#Tilordner koder etter fuge, og skriver til n liste. 

open IN, "dekomponerte_fellesnavn.txt";

#open LOGG, ">logg.OUT";
open OUT, ">alle_sammensetninger.OUT";

@longlist = "";

$fuge = "(a|ar|e|en|er|es|n|r|s|-)";
%fugehash = qw(a	c1
	ar	c2
	e	c3
	en	c4
	er	c5
	es	c6
	n	c7
	r	c8
	s	c9
	-	c10);

$punc = "_|-";

while (<IN>) {
	$code = "";

	chomp;
	$linje = $_;
	@felt = split ";", $linje;
	$corr = $felt[1];		#ortografi
	$decomp = $felt[2];		#dekomponering
	$pos = $felt[3];
	$decpos = $felt[4];
	$trans = $felt[11];
	$id = $felt[40];

	@ortledd = split /\+/, $decomp;		#hvert dekomponeringsledd

#print LOGG "New entry:\t$corr\t$decomp\n";

	for ($i = 0; $i < 10; $i++) {
		$curr = $ortledd[$i];
		$n = $i+1;
		$m = $i+2;
		$next = $ortledd[$n];
		$mext = $ortledd[$m];
#print LOGG "\$curr:\t$curr\n";
#print LOGG "\$next:\t$next\n";
#print LOGG "\$mext:\t$mext\n";

		if (($curr !~ /^$punc/) && ($next !~ /^$fuge$/) && ($next) && ($curr !~ /^$fuge$/)) {
			$code = "c0";
			$item = "$code"."\t$curr"."\t$decomp"."\t$corr"."\t$trans";
			push @longlist, $item;
		}
		
		elsif (($curr !~ /^$punc/) && ($next =~ /^$fuge$/) && ($next)) {
			$forledd = $curr.$next;
			$code = $fugehash{$next};
			$item = "$code"."\t$forledd"."\t$decomp"."\t$corr"."\t$trans";
			push @longlist, $item;
		}
	}

#print LOGG "--------------\n";

}

foreach $entry (sort @longlist) {
	print OUT "$entry\n";
}
