# !perl -w

#Programmet analyserer alle dekomponerte ikke-garbage ord, 
#og klassifiserer forledd ut fra hvordan de danner sammensetninger.
#Tilordner koder etter fuge, og skriver til n liste. 

open LEX, "fl_lh_no.LEX";
open OUT, ">fl_lh_no_s_addon.LEX";

%longlist = "";

while (<LEX>) {
	$code = "";
	$curr = "";
	$lccurr = "";
	$uccurr = "";
	$trans1 = "";
	$trans2 = "";

	chomp;
	$linje = $_;
	@felt = split /\t/, $linje;
	$code = $felt[0];
	$forledd = $felt[1];
	$trans = $felt[2];
	$ort = $felt[3];
	$orgtrans = $felt[4];
	$pos = $felt[5];
	$decomp = $felt[6];
	$id = $felt[7];

	if (($pos =~ /^(ng|np|nc)/) && ($code =~ /c0/) && ($ort !~ /s$/) && ($ort !~ /\!/)) {

		$code = "c9";		
		$ort1 = "$ort"."s";
		$trans1 = "$trans"."s";
		
		$item = "$code"."\t$ort1"."\t$trans1"."\t$decomp"."\t$trans"."\t$pos"."\t$decomp"."\t$id";
		$longlist{$ort1} = $item;
	}
}

foreach $key (sort keys %longlist) {
	print OUT "$longlist{$key}\n";
}
